<?php
/*

Insert the following lines in Joomla's index.php file, at line 280

//Start FileRun customization
session_start();
if (!$_SESSION['JoomlaSessionId']) {
	$_SESSION['JoomlaSessionId'] = $mainframe->_session->session_id;
}
//End FileRun customization

*/


/*

Customize this class in order to bind FileRun to a third party authentication source.

*/
class customAuth {
	/*
	
	This method can be blank.
	Useful for initializing variables.
	
	*/
	function customAuth() {
		$this->customSession = true;
		//init vars
		$this->config['joomla']['paths']['root'] = "H:/www/testing/joomla";
		$this->config['joomla']['paths']['config_file'] = gluePath($this->config['joomla']['paths']['root'], "/configuration.php");
		//get from Joomla config file
		require_once($this->config['joomla']['paths']['config_file']);
		$this->config['joomla']['db'] = array(
			"type" => "mysql",
			"host" => $mosConfig_host,
			"username" => $mosConfig_user,
			"password" => $mosConfig_password,
			"dbname" => $mosConfig_db,
			"tables_prefix" => $mosConfig_dbprefix
		);
		$this->config['joomla']['db']['tables'] = array(
				"users" => $this->config['joomla']['db']['tables_prefix']."users",
				"sessions" => $this->config['joomla']['db']['tables_prefix']."session",
		);
	}
	
	/*
	
	If this method exists, it will replace FileRun's session initialization (which does not require anything special).
	Useful when setting up a single login point.
	
	*/
	function initSession() {
		//continue using Joomla's session
		session_start();
		$this->JoomlaSessionId = $_SESSION['JoomlaSessionId'];
	}
	
	/*
	
	Get authentication session from thirdparty software and apply it locally
	
	*/
	function setSessionCredentials() {
		$this->db = NewADOConnection($this->config['joomla']['db']['type']);
		$this->db->Connect($this->config['joomla']['db']['host'], $this->config['joomla']['db']['username'], $this->config['joomla']['db']['password'], $this->config['joomla']['db']['dbname']);
		if ($this->db->_errorMsg) die("Database connection failed.");
		$this->db->debug = 0;
		
		if ($this->JoomlaSessionId) {
			$rs = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['sessions']."` WHERE session_id = '".$this->JoomlaSessionId."'");
		}
		
		//if user started Joomla session and is logged in
		if ($rs['userid']) {
			//get authentication data
			$this->joomlaUserInfo = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['users']."` WHERE `id` = '".addslashes($rs['userid'])."'");
			//$GLOBALS['vlad']->debug($this->joomlaUserInfo,1,1);
			
			$this->username = $this->joomlaUserInfo['username'];
			$split = explode(":", $this->joomlaUserInfo['password']);
			$this->password = $split[0];
			
			//do not edit this part
			$_SESSION['FileRun']['username'] = $this->username;
			$_SESSION['FileRun']['password'] = $this->password;
		} else {
			if ($this->JoomlaSessionId) {
				//user logged out from Joomla
				$_SESSION['JoomlaSessionId'] = false;
				$this->JoomlaSessionId = false;
				$_SESSION['FileRun'] = array();
			}
		}
	}
	
	/*
	
	This method is called on each FileRun request
	
	*/
	function authenticate($username, $password, $doLogin) {
		//get Joomla user info
		$this->joomlaUserInfo = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['users']."` WHERE `username` = '".addslashes($username)."'");
		$parts	= explode(":", $this->joomlaUserInfo['password']);
		$crypt	= $parts[0];
		$salt	= @$parts[1];
		if ($doLogin) {
			$testcrypt = md5($password.$salt);
		} else {
			$testcrypt = $password;
		}
		
		if ($crypt == $testcrypt) {
			$success = true;
			//set user's data for inserting into local database
			//note: the user will be added only once, if not found in local database
			$userData = array(
			    "username" => $username,
			    "password" => "",
			    "activated" => 1,
			    "last_login_date" => time(),
			    "email" => $this->joomlaUserInfo['email'],
			    "receive_notifications" => $this->joomlaUserInfo['sendEmail'],
			    "name" => $this->joomlaUserInfo['name'],
			    "company" => "",
			    "website" => ""
			);
			$userPerms = array(
				"role" => "",
				"admin_type" => (($this->joomlaUserInfo["usertype"] == "Super Administrator") ? "simple" : ""), //"indep"
				"admin_users" => 0,
				"admin_roles" => 0,
				"admin_notifications" => 0,
				"admin_logs" => 0,
				"admin_metadata" => 0,
				"admin_over" => (($this->joomlaUserInfo["usertype"] == "Super Administrator") ? "-ALL-" : ""),
				"admin_max_users" => 0,
				"admin_homefolder_template" => "",
				"homefolder" => str_replace("{USERNAME}", $username, $users_home_folder_template),
				"space_quota_max" => 0,
				"traffic_quota_max" => 0,
				"readonly" => 0,
				"upload" => 1,
				"download" => 1,
				"email" => 1,
				"weblink" => 1,
				"share" => 1,
				"users_may_see" => "-ALL-"
			);
			if ($userPerms['homefolder'] && !is_dir($userPerms['homefolder'])) {//create home folder
				@mkdir($userPerms['homefolder']);
			}
		}
		
		//do not edit this part
		if ($success) {//credentials checked
			$rs = array($userData, $userPerms);
			$rs['sessionPassword'] = $crypt;
		    return $rs;
		} else {
			return false;
		}
	}
	
	function logout() {
		if ($this->JoomlaSessionId) {
			$rs = $this->db->query("UPDATE `".$this->config['joomla']['db']['tables']['sessions']."` SET `username`='', `guest`=1, `userid`=0, `gid`=0, `usertype`='' WHERE session_id = '".$this->JoomlaSessionId."'");
		}
	}
}
?>