<?php
class customAuth {
	function customAuth() {
		$this->customSession = true;
		
		//config these two variables and the FileRun account settings from line #99 to #141
		$this->config['joomla']['paths']['root'] = "H:/www/temp/joomla1.7";
		$this->config['users_home_folder_template'] = "/path/to/{USERNAME}/home/folder/"; //{USERNAME} gets replaced with the username
		
		$this->config['joomla']['paths']['config_file'] = gluePath($this->config['joomla']['paths']['root'], "/configuration.php");
		//get Joomla config
		require_once($this->config['joomla']['paths']['config_file']);
		
		$this->JConfig = new JConfig;
		$this->config['joomla']['db'] = array(
			"type" => "mysql",
			"host" => $this->JConfig->host,
			"username" => $this->JConfig->user,
			"password" => $this->JConfig->password,
			"dbname" => $this->JConfig->db,
			"tables_prefix" => $this->JConfig->dbprefix
		);
		$this->config['joomla']['db']['tables'] = array(
				"users" => $this->config['joomla']['db']['tables_prefix']."users",
				"sessions" => $this->config['joomla']['db']['tables_prefix']."session",
		);
	}
	
	/*
	
	If this method exists, it will replace FileRun's session initialization (which does not require anything special).
	Useful when setting up a single login point.
	
	*/
	function initSession() {
		//continue using Joomla's session
		session_start();
		$this->JoomlaSessionId = $_COOKIE['joomla_session_id'];
	}
	
	/*
	
	Get authentication session from thirdparty software and apply it locally
	
	*/
	function setSessionCredentials() {
		$this->db = NewADOConnection($this->config['joomla']['db']['type']);
		$this->db->forceNewConnect = 1;
		$this->db->Connect($this->config['joomla']['db']['host'], $this->config['joomla']['db']['username'], $this->config['joomla']['db']['password'], $this->config['joomla']['db']['dbname']);
		if ($this->db->_errorMsg) die("Database connection failed.");
		
		$this->db->debug = 0;
		
		if ($this->JoomlaSessionId) {
			$rs = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['sessions']."` WHERE session_id = '".$this->JoomlaSessionId."'");
		}
		
		//if user started Joomla session and is logged in
		if ($rs['userid']) {
			//get authentication data
			$this->joomlaUserInfo = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['users']."` WHERE `id` = '".addslashes($rs['userid'])."'");
			//$GLOBALS['vlad']->debug($this->joomlaUserInfo,1,1);
			
			$this->username = $this->joomlaUserInfo['username'];
			$split = explode(":", $this->joomlaUserInfo['password']);
			$this->password = $split[0];
			
			//do not edit this part
			$_SESSION['FileRun']['username'] = $this->username;
			$_SESSION['FileRun']['password'] = $this->password;
		} else {
			if ($this->JoomlaSessionId) {
				//user logged out from Joomla
				$_SESSION['JoomlaSessionId'] = false;
				$this->JoomlaSessionId = false;
				setcookie("joomla_session_id", "", time()-3600, "/");
				$_SESSION['FileRun'] = array();
			}
		}
	}
	
	/*
	
	This method is called on each FileRun request
	
	*/
	function authenticate($username, $password, $doLogin) {
		//get Joomla user info
		$this->joomlaUserInfo = $this->db->GetRow("SELECT * FROM `".$this->config['joomla']['db']['tables']['users']."` WHERE `username` = '".addslashes($username)."'");
		$parts	= explode(":", $this->joomlaUserInfo['password']);
		$crypt	= $parts[0];
		$salt	= @$parts[1];
		if ($doLogin) {
			$testcrypt = md5($password.$salt);
		} else {
			$testcrypt = $password;
		}
		
		if ($crypt == $testcrypt) {
			$success = true;
			//set user's data for inserting into local database
			//note: the user will be added only once, if not found in local database
			$userData = array(
			    "username" => $username,
			    "password" => "",
				"cookie" => "",
				"owner" => "",	//id of independent admin user
				"registration_date" => time(),
			    "activated" => 1,
				"failed_login_attempts" => 0,
			    "last_login_date" => time(),
			    "email" => $this->joomlaUserInfo['email'],
			    "receive_notifications" => $this->joomlaUserInfo['sendEmail'],
				"new_email" => "",
			    "name" => $this->joomlaUserInfo['name'],
			    "company" => "",
			    "website" => "",
				"description" => "",
				"logo_url" => ""
			);
			
			$userIsAdmin = ($this->joomlaUserInfo["usertype"] == "Super Administrator");
			$userPerms = array(
				"role" => "", //role id
				"admin_type" => ($userIsAdmin ? "simple" : ""), //"indep"
				"admin_users" => $userIsAdmin ? 1 : 0,
				"admin_roles" => $userIsAdmin ? 1 : 0,
				"admin_notifications" => $userIsAdmin ? 1 : 0,
				"admin_logs" => $userIsAdmin ? 1 : 0,
				"admin_metadata" => $userIsAdmin ? 1 : 0,
				"admin_over" => (($this->joomlaUserInfo["usertype"] == "Super Administrator") ? "-ALL-" : ""),
				"admin_max_users" => 0,
				"admin_homefolder_template" => "",
				"homefolder" => str_replace("{USERNAME}", $username, $this->config['users_home_folder_template']),
				"space_quota_max" => 0,
				"space_quota_current" => 0,
				"traffic_quota_max" => 0,
				"traffic_quota_current" => 0,
				"readonly" => 0,
				"upload" => 1,
				"download" => 1,
				"download_folders" => 1,
				"read_comments" => 1,
				"write_comments" => 1,
				"email" => 1,
				"weblink" => 1,
				"share" => 1,
				"metadata" => 1,
				"users_may_see" => "-ALL-"
			);
			if ($userPerms['homefolder'] && !is_dir($userPerms['homefolder'])) {//create home folder
				@mkdir($userPerms['homefolder']);
			}
		}
		
		//do not edit this part
		if ($success) {//credentials checked
			$rs = array($userData, $userPerms);
			$rs['sessionPassword'] = $crypt;
		    return $rs;
		} else {
			return false;
		}
	}
	
	function logout() {
		if ($this->JoomlaSessionId) {
			setcookie("joomla_session_id", "", time()-3600, "/");
			$rs = $this->db->query("DELETE FROM `".$this->config['joomla']['db']['tables']['sessions']."` WHERE session_id = '".$this->JoomlaSessionId."'");
		}
	}
}
?>