<?php
/*

Customize this class in order to bind FileRun to a third party authentication source.

*/
class customAuth {
	/*
	
	This method can be blank.
	Useful for initializing variables.
	
	*/
	function customAuth() {
		$this->config = array(
			'usersHomeFolderTemplate' => '/home/users/{USERNAME}',
			'db' => array(
				"type" => "mysql",
				"server" => "",
				"username" => "",
				"password" => "",
				"dbname" => "",
				"usersTableName" => "users",
				"usernameFieldName" => "username",
				"passwordFieldName" => "password"
			)
		);
	}
	
	/*
	
	If this method exists, it will replace FileRun's session initialization (which 

does not require anything special).
	Useful when setting up a single login point.
	
	*/
	
	/*
	
	Get authentication session from thirdparty software and apply it locally
	
	*/
	function setSessionCredentials() {
		$this->db = NewADOConnection($this->config['db']['type']);
		$this->db->Connect($this->config['db']['server'], $this->config['db']['username'], $this->config['db']['password'], $this->config['db']['dbname'], true);
		if ($this->db->_errorMsg) die("Database connection failed.");
		$this->db->debug = false;
	}
	
	/*
	
	This method is called on each FileRun request
	
	*/
	function authenticate($username, $password, $doLogin) {
		//get user info
		$this->userInfo = $this->db->GetRow("SELECT * FROM `".$this->config['db']['usersTableName']."` WHERE `".$this->config['db']['usernameFieldName']."` = '".addslashes($username)."'");
		
		$dbPass = $this->userInfo[$this->config['db']['passwordFieldName']];
		if (!$doLogin) {
			$dbPass = md5($dbPass);
		}
		if ($password == $dbPass) {
			$success = true;
			//set user's data for inserting into local database
			//note: the user will be added only once, if not found in local database
			$userData = array(
			    "username" => $username,
			    "password" => $this->userInfo[$this->config['db']['passwordFieldName']],
			    "is_admin" => 0,
			    "activated" => 1,
			    "last_login_date" => time(),
			    "email" => $this->userInfo['email'],
			    "receive_notifications" => 0,
			    "name" => $this->userInfo['firstname']." ".$this->userInfo['lastname'],
			    "company" => $this->userInfo['company'],
			    "website" => $this->userInfo['website']
			);
			$userPerms = array(
				"role" => "",
				"admin_type" => "",
				"admin_users" => 0,
				"admin_roles" => 0,
				"admin_notifications" => 0,
				"admin_logs" => 0,
				"admin_metadata" => 0,
				"admin_over" => "",
				"admin_max_users" => 0,
				"admin_homefolder_template" => "",
				"homefolder" => str_replace("{USERNAME}", $username, $this->config['usersHomeFolderTemplate']),
				"space_quota_max" => 0,
				"traffic_quota_max" => 0,
				"readonly" => 0,
				"upload" => 1,
				"download" => 1,
				"email" => 1,
				"weblink" => 1,
				"share" => 1,
				"users_may_see" => "-ALL-"
			);
			if ($userPerms['homefolder'] && !is_dir($userPerms['homefolder'])) {//create home folder
				@mkdir($userPerms['homefolder']);
			}
		}
		
		//do not edit this part
		if ($success) {//credentials checked
			$rs = array($userData, $userPerms);
			if ($doLogin) {
				$rs['sessionPassword'] = md5($password);
			}
		    return $rs;
		} else {
			return false;
		}
	}
}
?>