<?
/*

Customize this class in order to bind FileRun to a third party authentication source.

*/
class customAuth {
	/*
	
	This method can be blank.
	Useful for initializing variables.
	
	*/
	function customAuth() {
		$this->config = array(
			'usersHomeFolderTemplate' => '/home/users/{USERNAME}',
			'db' => array(
				"type" => "mysql",
				"server" => "localhost",
				"username" => "username",
				"password" => "password",
				"dbname" => "oss6",
				"usersTableName" => "oss6_users",
				"IDFieldName" => "id",
				"usernameFieldName" => "username",
				"passwordFieldName" => "password"
			)
		);
	}
	
	/*
	
	If this method exists, it will replace FileRun's session initialization (which 

does not require anything special).
	Useful when setting up a single login point.
	
	*/
	function initSession() {
		session_start();
	}
	/*
	
	Get authentication session from thirdparty software and apply it locally
	
	*/
	function setSessionCredentials() {
		$this->db = NewADOConnection($this->config['db']['type']);
		$this->db->Connect($this->config['db']['server'], $this->config['db']['username'], $this->config['db']['password'], $this->config['db']['dbname'], true);
		if ($this->db->_errorMsg) die("Database connection failed.");
		$this->db->debug = false;
		
		if ($_SESSION['attributes']['org.mojavi.authenticated']) {
			//get authentication data
			
			$this->omniSecureUserInfo = $this->db->GetRow("SELECT * FROM `".$this->config['db']['usersTableName']."` WHERE `".$this->config['db']['IDFieldName']."` = '".addslashes($_SESSION['attributes']['org.mojavi.userid'])."' AND closed =''");
			
			//do not edit this part
			$_SESSION['FileRun']['username'] = $this->omniSecureUserInfo['username'];
			$_SESSION['FileRun']['password'] = $this->omniSecureUserInfo['password'];
		} else {
			//user logged out from Omnisecure
			$_SESSION['FileRun'] = array();
		}
	}
	
	/*
	
	This method is called on each FileRun request
	
	*/
	function authenticate($username, $password, $doLogin) {
		//get user info
		$this->userInfo = $this->db->GetRow("SELECT * FROM `".$this->config['db']['usersTableName']."` WHERE `".$this->config['db']['usernameFieldName']."` = '".addslashes($username)."'");
		$dbPass = $this->userInfo[$this->config['db']['passwordFieldName']];
		
		if ($doLogin) {
			$password = md5($password);
		} else {
		}
		
		if ($password == $dbPass) {
			$success = true;
			//set user's data for inserting into local database
			//note: the user will be added only once, if not found in local database
			
			$userData = array(
			    "username" => $username,
			    "password" => "",
				"cookie" => "",
				"owner" => "",	//id of independent admin user
				"registration_date" => time(),
			    "activated" => 1,
				"failed_login_attempts" => 0,
			    "last_login_date" => time(),
			    "email" => $this->userInfo['email'],
			    "receive_notifications" => 0,
				"new_email" => "",
			    "name" => $this->userInfo['firstname']." ".$this->userInfo['lastname'],
			    "company" => $this->userInfo['company'] ? $this->userInfo['company'] : "",
			    "website" => $this->userInfo['website'] ? $this->userInfo['website'] : "",
				"description" => "",
				"logo_url" => ""
			);
			$userIsAdmin = false;
			$userPerms = array(
				"role" => "", //role id
				"admin_type" => ($userIsAdmin ? "simple" : ""), //"indep"
				"admin_users" => $userIsAdmin ? 1 : 0,
				"admin_roles" => $userIsAdmin ? 1 : 0,
				"admin_notifications" => $userIsAdmin ? 1 : 0,
				"admin_logs" => $userIsAdmin ? 1 : 0,
				"admin_metadata" => $userIsAdmin ? 1 : 0,
				"admin_over" => ($userIsAdmin ? "-ALL-" : ""),
				"admin_max_users" => 0,
				"admin_homefolder_template" => "",
				"homefolder" => str_replace("{USERNAME}", $username, $this->config['usersHomeFolderTemplate']),
				"space_quota_max" => 0,
				"space_quota_current" => 0,
				"traffic_quota_max" => 0,
				"traffic_quota_current" => 0,
				"readonly" => 0,
				"upload" => 1,
				"download" => 1,
				"email" => 1,
				"weblink" => 1,
				"share" => 1,
				"users_may_see" => "-ALL-"
			);
			
			if ($userPerms['homefolder'] && !is_dir($userPerms['homefolder'])) {//create home folder
				@mkdir($userPerms['homefolder']);
			}
		}
		
		//do not edit this part
		if ($success) {//credentials checked
			$rs = array($userData, $userPerms);
			if ($doLogin) {
				$rs['sessionPassword'] = $password;
			}
		    return $rs;
		} else {
			return false;
		}
	}
}
?>