<?php
/*
	Edit image files with Pixlr.com
*/
class custom_pixlr {
	function init() {
		global $locale;
		$this->localeSection = "Custom Actions: Pixlr";
		$this->JSconfig = array(
			"title" => $locale->get("Pixlr", $this->localeSection),
			"icon" => "/customizables/custom_actions/pixlr/icon.png",
			"extensions" => array("jpg", "jpeg", "gif", "png", "psd", "bmp", "pxd"),
			"popup" => true,
			"requiredUserPerms" => array("download", "upload"),
			"createNew" => array(
				"title" => $locale->get("Image with Pixlr", $this->localeSection),
				"defaultFileName" => $locale->get("Untitled.png", $this->localeSection)
			)
		);
		$this->outputName = "image";
	}
	function run() {
		if (!is_file($this->data['filePath'])) {
			echo "File not found!";
			exit();
		}
		$weblinkInfo = $this->weblinks->createForService($this->data['filePath'], false, $this->data['relativePath']);
		if (!$weblinkInfo) {
			echo "Failed to setup weblink";
			exit();
		}
		$this->data['fileURL'] = $this->weblinks->getURL(array("id" => $weblinkInfo['id'], "password" => $weblinkInfo['password']));
		$this->data['saveURL'] = $this->weblinks->getSaveURL($weblinkInfo['id'], $weblinkInfo['password'], "pixlr");
		require($this->path."/display.php");
		global $log;
		$log->add(false, "preview", array(
			"relative_path" => gluePath($this->data['relativePath'], $this->data['fileName']),
			"full_path" => $this->data['filePath'],
			"method" => "pixlr"
		));
	}
	function createBlankFile() {
		global $myfiles, $users, $locale;
		if (!$users->userPerms->currentUser['upload']) {exit();}
		$blankFilePath = gluePath($this->path, "blank.png");
		$rs = $myfiles->newFile($this->data['relativePath'], $this->data['fileName'], $blankFilePath);
		if ($rs) {
			jsonOutput(array("rs" => true, "filename" => $this->data['fileName'], "msg" => $locale->get("Blank image created successfully", $this->localeSection)));
		} else {
			jsonOutput(array("rs" => false, "msg" => $myfiles->error['msg']));
		}
	}
	function getNewFileContents() {
		if ($_FILES[$this->outputName]['tmp_name']) {
			$contents = file_get_contents($_FILES[$this->outputName]['tmp_name']);
		}
		return $contents;
	}
}
?>