<?php
class custom_text_editor {
	function init() {
		global $locale;
		$this->localeSection = "Custom Actions: Text Editor";
		$this->JSconfig = array(
			"title" => $locale->get("Text Editor", $this->localeSection),
			"icon" => "/customizables/custom_actions/text_editor/icon.png",
			"extensions" => array("txt", "csv", "html", "htm", "xml", "js", "css", "php", "inc", "cfg"),
			"popup" => true,
			"createNew" => array(
				"title" => $locale->get("Text File", $this->localeSection),
				"defaultFileName" => $locale->get("Untitled.txt", $this->localeSection)
			),
			"requiredUserPerms" => array("download", "upload")
		);
	}
	function run() {
		global $log, $fileman;
		$fileman->checkPerms("download");
		$this->data['fileContents'] = file_get_contents($this->data['filePath']);
		require($this->path."/display.php");
		$log->add(false, "preview", array(
			"relative_path" => gluePath($this->data['relativePath'], $this->data['fileName']),
			"full_path" => $this->data['filePath'],
			"method" => "text_editor"
		));
	}
	function saveChanges() {
		global $str, $myfiles, $locale, $fileman;
		$fileman->checkPerms("upload");
		$textContents = $str->fromHTML($_POST['textContents']);
		$rs = $myfiles->newFile($this->data['relativePath'], $this->data['fileName'], false, $textContents);
		if ($rs) {
			jsonOutput(array("rs" => true, "filename" => $this->data['fileName'], "msg" => $locale->get("Text file successfully saved", $this->localeSection)));
		} else {
			jsonOutput(array("rs" => false, "msg" => $myfiles->error['msg']));
		}
	}
	function createBlankFile() {
		global $myfiles, $locale, $fileman;
		$fileman->checkPerms("upload");
		$rs = $myfiles->newFile($this->data['relativePath'], $this->data['fileName'], false, "");
		if ($rs) {
			jsonOutput(array("rs" => true, "filename" => $this->data['fileName'], "msg" => $locale->get("Text file successfully created", $this->localeSection)));
		} else {
			jsonOutput(array("rs" => false, "msg" => $myfiles->error['msg']));
		}
	}
}
?>