<?php
/*
	Zoho Viewer
*/
class custom_zoho_view {
	function init() {
		
		//Set here your Zoho API key:
		$this->APIKey = "0706fa28460d4cacc49928f5a2714301";
		$this->skey = "f1171d4e0b8faf38502b9d1da0c5818a";
		
		$this->URL = "https://viewer.zoho.com/api/view.do";
		$this->JSconfig = array(
			"title" => "Zoho Viewer",
			"icon" => "/customizables/custom_actions/zoho/icon.gif",
			"extensions" => array(
				"doc", "docx", "odt", "rtf",
				"xls", "xlsx", "ods",
				"ppt", "pps", "pptx", "odp",
				"sxw", "sxc", "sxi",
				"html",
				"csv", "tsv",
				"txt",
				"pdf", "wpd"
			),
			"popup" => true,
			"requiredUserPerms" => array("download")
		);
		$this->outputName = "content";
	}
	function run() {
		global $fm;
		$fileName = $fm->basename($this->data['filePath']);
		$extension = $fm->getExtension($fileName);
		
		if (!function_exists("curl_init")) {
			echo "This feature requires the <a href=\"http://www.php.net/manual/en/curl.installation.php\" target=\"_blank\">PHP cURL</a> extension. Please contact the server administrator about enabling it.";
			exit();
		}
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_VERBOSE, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible;)");
		curl_setopt($ch, CURLOPT_URL, $this->URL);
		curl_setopt($ch, CURLOPT_POST, true);
		
		$post = array(
			"apikey" => $this->APIKey,
			"skey" => $this->skey,
			"displaylinks" => "false",
			"displayfilename" => "false",
			"file" => "@".$this->data['filePath']
		);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  2);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		$response = curl_exec($ch);
		curl_close($ch);
		
		$rs = $this->parseZohoReply($response);
		
		if ($rs->response->result == "Success") {
			global $log;
			$log->add(false, "preview", array(
				"relative_path" => gluePath($this->data['relativePath'], $this->data['fileName']),
				"full_path" => $this->data['filePath'],
				"method" => "zoho"
			));
			header("Location: ".$rs->response->url."");
			exit();
		} else {
			echo "<strong>Zoho:</strong>";
			echo "<div style=\"margin:5px;border:1px solid silver;padding:5px;overflow:auto;\"><pre>";
			echo $response;
			echo "</pre></div>";
		}
	}
	
	function parseZohoReply($reply) {
		return json_decode($reply);
	}
}
?>