var FR = {
	chooser: false,
	UI: {tree: {},translations:[]}
}
Ext.onReady(function() {
	var tb = [];
    tb.push({
		id: 'addUsersBtn',
        text: FR.T('Add Users'), cls: 'x-btn-text-icon',
		icon: URLRoot+'/images/fileman/interface/icons/user_add.gif',
        handler: function() {
			if (!FR.chooser) {FR.chooser = new UserChooser({showSelf:true});}
			FR.chooser.show(FR.addUsersBtn.getEl(), function(data) {
				treeRoot = FR.UI.tree.rootNode;
				if (data.users) {
					Ext.each(data.users, function(user) {
						if (!treeRoot.findChild('uid', user.uid)) {
							addToList({
								name: user.name, text: user.name, leaf: true,
								cls:'user', iconCls:'user', uid: user.uid
							})
						}
					});
				}
			});
		 }
		});
	tb.push({
		id: 'removeBtn', text: FR.T('Remove Selected'), cls: 'x-btn-text-icon',
		icon: URLRoot+'/images/fileman/interface/icons/user_delete.gif', disabled: true,
        handler: function() {
			FR.UI.tree.rootNode.removeChild(FR.UI.tree.panel.getSelectionModel().getSelectedNode());
			if (FR.UI.tree.rootNode.firstChild) {FR.UI.tree.rootNode.firstChild.select();}
		}
	});
	FR.UI.tree.panel = new Ext.tree.TreePanel({
		bbar: tb, animate: true, containerScroll: true, rootVisible:false, width:305, height:150
	});
	FR.UI.tree.rootNode = new Ext.tree.TreeNode({
		text: 'Root', cls:'album-node', iconCls:'folder'
	});
	FR.UI.tree.panel.setRootNode(FR.UI.tree.rootNode);
	FR.UI.tree.panel.getSelectionModel().on('selectionchange', function(sel, node){
		if (sel.getSelectedNode()) {
			FR.removeBtn.enable();
		} else {
			FR.removeBtn.disable();
		}
	});
	FR.UI.tree.panel.render('usersList');
	var tbItems = FR.UI.tree.panel.getBottomToolbar().items;
	FR.removeBtn = tbItems.map['removeBtn'];
	FR.addUsersBtn = tbItems.map['addUsersBtn'];
	
	if (FR.usersInGroup) {
		Ext.each(FR.usersInGroup, function(u) {
			addToList({
				name: u.name, text: u.name, leaf: true,
				cls:'user', iconCls:'user', uid: u.uid
			})
		});
	}
});
function addToList(data) {
	var newTreeNode = new Ext.tree.TreeNode(data);
	FR.UI.tree.rootNode.appendChild(newTreeNode);
	if (!FR.UI.tree.panel.getSelectionModel().getSelectedNode()) {
		newTreeNode.select();
	}
}
function submitForm(url) {
	var params = 'name='+encodeURIComponent(document.theForm.name.value);
	params += '&description='+encodeURIComponent(document.theForm.description.value);
	FR.UI.tree.rootNode.eachChild(function(node) {
		if (!node.disabled) {
			params += '&users[]='+node.attributes.uid;
		}
	});
	new Ajax.Request(
	url, 
	{
		method: 'post',
		parameters: params,
		onSuccess: function(originalRequest) {
			response = eval('('+originalRequest.responseText+')');
			if (response.rs) {
				document.location.href = response.redirect;
			} else {
				alert(response.msg);
			}
		}
	});
}