Ext.onReady(function(){
    FR.store = new Ext.data.SimpleStore({
        fields: [
           {name: 'id'}, {name: 'username'}, {name: 'name'}, {name: 'max'},
		   {name: 'maxNice'}, {name: 'used'}, {name: 'usedNice'}, {name: 'percent'}
        ]
    });
    FR.store.loadData(FR.users);
	FR.sb = new Ext.ux.StatusBar({id: 'my-status', defaultText:'&nbsp;'});
    FR.grid = new Ext.grid.GridPanel({
        store: FR.store,
		cm: new Ext.grid.ColumnModel({
			defaults: {sortable: true},
	        columns: [
				{header: FR.T("Id"), width: 30,  dataIndex: 'id'},
	            {id:'uname', header: FR.T("Name"), width: 160, dataIndex: 'name'},
				{id:'usrname', header: FR.T("Username"), width: 160, dataIndex: 'username'},
				{header: FR.T("Quota"), width: 75, renderer: function(v, m, r) {return r.data.maxNice;}, dataIndex: 'max'},
	            {header: FR.T("Used"), width: 75, renderer: function(v, m, r) {
					if (r.data.max > 0 && (v >= r.data.max)) {
	          			return '<span style="color:red;">' +r.data.usedNice+ '</span>';
					} else {
						return r.data.usedNice;
					}
				}, dataIndex: 'used'},
	            {header: FR.T("Usage"), width: 85, renderer: function(v, m, r) {
					if (v > FR.highlightLimit) {
	          			return '<span style="color:red;">' +v+ '%</span>';
					} else {
						if (v) {return v+'%';} else {return '';}
					}
				}, dataIndex: 'percent'}
	        ]
		}),
        autoExpandColumn: 'uname',
        height: 390,
        width: 600,
		bbar: FR.sb
    });
    FR.grid.render('users-quota-grid');

FR.getQuota = function(uid, r) {
	FR.sb.showBusy(FR.T('Calculating quota usage for "%1"...').replace('%1', r.data.name));
	Ext.Ajax.request({
		url: URLRoot+'/?module=admin&section=tools&page=traffic_usage&action=get_quota&uid='+uid,
		method: 'GET',
		success: function(result, request) {
			try {
				rs = Ext.util.JSON.decode(result.responseText);
				r.set('max', rs.max);
				r.set('maxNice', rs.maxNice);
				r.set('used', rs.used);
				r.set('usedNice', rs.usedNice);
				r.set('percent', rs.percent);
				r.commit();
			} catch(er) {}
			
			FR.currentUID++;
			if (FR.store.data.items[FR.currentUID]) {
				FR.getQuota(FR.store.data.items[FR.currentUID].data.id, FR.store.data.items[FR.currentUID]);
			} else {
				FR.sb.clearStatus();
			}
		}
	});
}
	
	window.setTimeout(function() {
		if (FR.store.data.length > 0) {
			FR.currentUID = 0;
			FR.getQuota(FR.store.data.items[FR.currentUID].data.id, FR.store.data.items[FR.currentUID]);
		}
	}, 500);
});