FR = {UI: {translations:[]}};

Ext.onReady(function() {
	Ext.override(Ext.grid.GridView, {
	    templates: {
	        cell: new Ext.Template(
	                    '<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
	                    '<div class="x-grid3-cell-inner x-grid3-col-{id}" {attr}>{value}</div>',
	                    "</td>"
	            )
	    }
	});
	var store = new Ext.data.Store({
		proxy: new Ext.data.HttpProxy({
			url: URLRoot+'/?module=comments&section=ajax&page=index&action=load'
		}),
		reader: new Ext.data.JsonReader({
			root: 'comments',
			totalProperty: 'totalCount',
			id: 'id',
			fields: [
				'id', 'date_added', 'date_modified', 'uid', 'val', 'username', 'fullName'
			]
		})
    });
	store.on('load', function(store, records, opts) {
		if (store.reader.jsonData.msg) {
			window.parent.FR.UI.feedback(store.reader.jsonData.msg);
		}
	});
    var cm = new Ext.grid.ColumnModel([{
			header: FR.T('Author'), dataIndex: 'fullName',
			width: 120,
			hideable: false, sortable: false,
			renderer: function(val, meta, record) {
				return record.data.fullName+'<div style="color:silver">'+Date.parseDate(record.data.date_added, "Y-m-d H:i:s").format("m/d/Y h:i A");+'</div>';
			}
		},{
			id: 'comment', header: FR.T('Comment'), dataIndex: 'val',
			hideable: false, sortable: false,
			width: 400
		}]);

	// by default columns are sortable
	cm.defaultSortable = true;

	if (window.parent.User.perms.write_comments) {
		var bbar = [
			{
		    text: FR.T('Add comment'),
			cls: 'x-btn-text-icon',
			icon: URLRoot+'/images/fileman/interface/icons/comment_add.gif',
			handler: function() {
				Ext.MessageBox.show({
					title: FR.T('Add comment'),
					msg: FR.T('Type in your comment'),
					width:300,
					buttons: Ext.MessageBox.OKCANCEL,
					multiline: true,
					fn: function(btn, text) {
						if (btn == 'ok') {
							Ext.Ajax.request({
								url: URLRoot+'/?module=comments&section=ajax&page=index&action=add',
								success: function(originalRequest) {
									response = eval('('+originalRequest.responseText+')');
									if (response.rs) {
										grid.getStore().load({params:FR.params});
									}
									window.parent.FR.UI.feedback(response.msg);
								},
								params: {path: encodeURIComponent(FR.path), filename: encodeURIComponent(FR.filename), comment: encodeURIComponent(text)}
							});
						}	
					}
				});
			}
			},{
			id: 'removeBtn',
			text: FR.T('Remove comment'),
			cls: 'x-btn-text-icon', disabled: true,
			icon: URLRoot+'/images/fileman/interface/icons/comment_delete.gif',
			handler: function() {
				commentId = grid.getSelectionModel().getSelected().data.id;
				Ext.Ajax.request({
					url: URLRoot+'/?module=comments&section=ajax&page=index&action=remove',
					success: function(originalRequest) {
						response = eval('('+originalRequest.responseText+')');
						if (response.rs) {
							grid.getStore().load({params:FR.params});
						}
						window.parent.FR.UI.feedback(response.msg);
					},
					params: {path: encodeURIComponent(FR.path), filename: encodeURIComponent(FR.filename), commentId: commentId}
				});
			}
			}
		];
	} else {
		var bbar = false;
	}
    var grid = new Ext.grid.GridPanel({
		el: 'the-grid',
		autoExpandColumn: 'comment',
		selModel: new Ext.grid.RowSelectionModel({singleSelect:true}),
		border: false,
		store: store, cm: cm,
		loadMask: true, enableHdMenu: false,
		viewConfig: {
			forceFit:true,
			getRowClass : function(record, rowIndex, p, store){return 'x-grid3-row-collapsed';}
		},
		bbar: bbar
	});
	
	grid.getSelectionModel().on('selectionchange', function(sm, rowIdx, r) {
		if (window.parent.User.perms.write_comments) {
			if (sm.getCount() == 1) {
				Ext.getCmp('removeBtn').enable();} else {Ext.getCmp('removeBtn').disable();
			}
		}
	});
	
	grid.render();
	window.parent.Ext.get(window.parent.FR.UI.popups[FR.popupId].getLayout().container.body.dom).unmask();
	FR.params = {
		path: encodeURIComponent(FR.path),
		filename: encodeURIComponent(FR.filename)
	}
	store.load({params:FR.params});
	viewport = new Ext.Viewport({
		layout: 'border',
		border: false, hideBorders: true,
		items: [
			{
				region: 'center', layout: 'fit',
				autoHeigh: true, border: false, hideBorders: true,
				items: grid
			}
		]
	});
});