Ext.onReady(function() {
	FR.update = function() {
		FR.UI.updateAttachments();
		FR.UI.updatePath();
	}
	FR.UI.getFilesList = function() {
		var selectedItems = window.parent.FR.UI.grid.getSelectedFiles();
		var html = '';
		FR.filenames = '';
		Ext.each(selectedItems, function(item) {
			html += '<div style="white-space:nowrap;"><img src="'+URLRoot+'/images/fileman/file_icons/small/'+item.icon+'" width="16" height="16" border="0"> '+item.filename+'<span style="color:gray;font-size:11px;"> ('+item.nice_filesize+')</span></div>';
			FR.filenames += '|'+item.filename;
		})
		return html;
	}
	FR.UI.updateAttachments = function() {
		Ext.get('attachments').update(FR.UI.getFilesList());
	}
	FR.UI.updatePath = function() {
		FR.path = window.parent.FR.currentPath;
	}
	
	var addressHistory = [];
	var addressHistoryStoreData = [];
	var histCookie = Ext.util.Cookies.get("historyAddresses");
	if (histCookie != null) {
		addressHistory = Ext.util.JSON.decode(histCookie);
		var t = [];
		Ext.each(addressHistory, function(item) {if (item.length > 3){t.push([item]);}});
		addressHistoryStoreData = t;
	}
	
	FR.UI.form = new Ext.FormPanel({
		autoHeight: true, border: false,
		defaultType: 'textfield',
		labelAlign: 'right', labelWidth: 90,
		bodyStyle: 'margin-left:5px;margin-top:5px;',
		defaults: {width: 300, labelStyle: 'white-space:nowrap'},
		items: [
			{fieldLabel: FR.T('From'), name: 'from', minLength: 5, value: FR.defaultFrom, allowBlank: false},
			{fieldLabel: FR.T('To'), id: 'toField', name: 'to', allowBlank: false,
				xtype: 'combo', id: 'toField', emptyText: FR.T('Separate recipients by ,'),
				store: new Ext.data.ArrayStore({
					fields: ['addr'],
					data: addressHistoryStoreData,
					sortInfo: {field: 'addr', direction: 'DESC'}
				}),
				typeAhead: true,
				displayField: 'addr',
				mode: 'local',
				triggerClass: 'x-form-address-trigger',
				onTriggerClick: function(e, btn) {
					if (!FR.chooser) {
						FR.chooser = new UserChooser();
					}
					FR.chooser.show(btn, function(data) {
						if (data.users) {
							Ext.each(data.users, function(user) {
								var s = Ext.getCmp('toField').getValue();
								s += s.length > 0 ? ', ' : '';
								Ext.getCmp('toField').setValue(s+user.name);
							});
						}
						if (data.groups) {
							Ext.each(data.groups, function(group) {
								var s = Ext.getCmp('toField').getValue();
								s += s.length > 0 ? ', ' : '';
								Ext.getCmp('toField').setValue(s+'['+group.name+']');
							});
						}
					});
					FR.chooser.clearChecked();
				}
			},
			{fieldLabel: FR.T('Subject'), name: 'subject', allowBlank: false},
			{fieldLabel: FR.T('Message'), xtype: 'textarea', height: 120, name: 'message'},
			{fieldLabel: FR.T('Attachments'), xtype: "field", value: '', autoCreate: {tag: 'div', children: [
				{tag: 'div', id: 'attachments', 'class': 'x-form-text', style:'overflow-y:scroll;height:62px;', html: 'Loading...'}, 
				{tag: 'div', style:(window.parent.User.perms.weblink && window.parent.User.perms.download)?'':'display:none', html: '<div style="margin-top:5px;"><input type="checkbox" name="weblinks" id="weblinks" value="1" onclick="FR.clickWebLinkOption(this)"><label for="weblinks"> '+FR.T('Send WebLinks instead of attaching the files.')+'</label></div>'}
			]}}
		]
    });
	
	FR.UI.webLinksForm = new Ext.FormPanel({
		height: 180, border: false,
		defaultType: 'textfield',
		labelAlign: 'right', labelWidth: 170,
		bodyStyle: 'padding-top:10px;padding-left:10px;',
		defaults:{width: 180, labelStyle: 'white-space:nowrap'},
		items: [
			{fieldLabel: FR.T('Expiration date', 2), name: 'expiry', xtype: 'datefield', id: 'wl_expiry', minValue: new Date(), value: ''},
			{fieldLabel: FR.T('Download limit', 2), name: 'download_limit', width: 50, id: 'wl_download_limit'},
			{fieldLabel: FR.T('Set a password', 2), name: 'password', id: 'wl_password', value: ''},
			{fieldLabel: FR.T('Get notified on downloads', 2), xtype: 'checkbox', name: 'notify', id: 'wl_notify', value: '1'}
		]
    });
	
	FR.clickWebLinkOption = function(checkbox) {
		if (!checkbox.checked) {return false;}
		if (!FR.webLinksOptWin) {
			FR.webLinksOptWin = new Ext.Window({
				title: FR.T('Web Link Options'), width: 390, height: 180, resizable: false, draggable: false,
				modal: true, closeAction: 'hide', closable: false, items: FR.UI.webLinksForm,
				bbar: [
					'->',
					{
						text: FR.T('Ok'), cls: 'x-btn-text-icon', 
						icon: URLRoot+'/images/fileman/interface/icons/tick.gif',
						handler: function(){FR.webLinksOptWin.hide();}
					}
				]
			});
		}
		FR.webLinksOptWin.show();
	}
	new Ext.Viewport({
		layout: 'border', border: false,
		items: [
			{
				region: 'center', layout: 'fit', border: false,
				items: [FR.UI.form],
				bbar: [
				'->',
				{
					icon: URLRoot+'/images/fileman/interface/icons/email_attach.gif',
					cls: 'x-btn-text-icon',
					text: FR.T("Send"),
					handler: function() {
						FR.UI.form.getForm().submit({
							waitMsg: FR.T('Sending e-mail, please wait...'),
						    clientValidation: true,
						    url: URLRoot+'/?module=email&section=ajax&page=send',
						    params: {
						        path: FR.path,
								filenames: FR.filenames,
								wl_expiry: Ext.getCmp('wl_expiry').getRawValue(),
								wl_download_limit: Ext.getCmp('wl_download_limit').getValue(),
								wl_password: Ext.getCmp('wl_password').getValue(),
								wl_notify: (Ext.getCmp('wl_notify').getValue() ? 1 : 0)
						    },
						    success: function(form, action) {
								if (action.result) {
									Ext.Msg.alert('', action.result.msg, function() {
										window.parent.FR.UI.popups.emailFiles.hide();
									});
									var recipients = Ext.getCmp('toField').getValue().split(',');
									Ext.each(recipients, function(item) {
										item = Ext.util.Format.trim(item);
										if (addressHistory.indexOf(item) == -1) {addressHistory.push(item);}
									});
									var expiry = new Date();
									expiry.setTime(expiry.getTime()+(90*24*60*60));
									Ext.util.Cookies.set("historyAddresses", Ext.util.JSON.encode(addressHistory), expiry);
								} else {
									Ext.Msg.alert('', 'Invalid server reply');
								}
						    },
						    failure: function(form, action) {
								switch (action.failureType) {
									case Ext.form.Action.CLIENT_INVALID:
										Ext.Msg.alert('', FR.T("Please make the appropriate <br>changes to the highlighted fields."));
									break;
									case Ext.form.Action.CONNECT_FAILURE:
										Ext.Msg.alert('', "Ajax communication failed.");
									break;
									case Ext.form.Action.SERVER_INVALID:
										Ext.Msg.alert('', 'Invalid server reply');
								}
						    }
						});
					}
				}
				]
			}
		]
	});
	
	window.parent.Ext.get(window.parent.FR.UI.popups.emailFiles.getLayout().container.body.dom).unmask();
	FR.update();
});