var FR = {
	chooser : false, 
	UI: {
		tree: {},
		translations:[]
	}
}
Ext.onReady(function() {
	FR.update = FR.getInfo;
	
	FR.popup = window.parent.FR.UI.popups.folderOptions;
	FR.popupBody = window.parent.Ext.get(FR.popup.getLayout().container.body.dom);
	FR.popupBody.unmask();
	
	var tb = [];
	var bb = [];
    tb.push({
		id: 'addUsersBtn',
         text: FR.T('Add Users'),
         cls: 'x-btn-text-icon',
		 icon: URLRoot+'/images/fileman/interface/icons/user_add.gif',
         handler: function() {
			if (!FR.chooser) {FR.chooser = new UserChooser();}
			FR.chooser.show(FR.addUsersBtn.getEl(), function(data) {
				if (data.users) {
					Ext.each(data.users, function(user) {
						if (!FR.UI.tree.rootNode.findChild('uid', user.uid)) {
							FR.addToList({
								name: user.name, text: user.name, leaf: true,
								cls:'user', iconCls:'user', uid: user.uid,
								perms: {upload: 1, download: 1, alter: 0}
							})
						}
					});
				}
				if (data.groups) {
					Ext.each(data.groups, function(group) {
						if (!FR.UI.tree.rootNode.findChild('gid', group.gid)) {
							FR.addToList({
								name: group.name, text: group.name, leaf: true,
								cls:'group', iconCls:'group', gid: group.gid,
								perms: {upload: 1, download: 1, alter: 0}
							});
						}
					});
				}
			});
		 }
	});
	tb.push({
		id: 'removeBtn',
        text: FR.T('Remove Selected'),
        cls: 'x-btn-text-icon',
		icon: URLRoot+'/images/fileman/interface/icons/user_delete.gif',
		disabled: true,
        handler: function() {
		 	FR.UI.tree.rootNode.removeChild(FR.UI.tree.panel.getSelectionModel().getSelectedNode());
			if (FR.UI.tree.rootNode.firstChild) {FR.UI.tree.rootNode.firstChild.select();}
		}
	});
	bb.push('->');
	bb.push({
		xtype: 'tbbutton',
		text: FR.T("Save"), cls: 'x-btn-text-icon', icon: URLRoot+'/images/fileman/interface/icons/disk.gif',
		handler: function() {
			var pars = '&path='+encodeURIComponent(window.parent.FR.currentFolderOptionsPath);
			FR.UI.tree.rootNode.eachChild(function(node) {
				if (!node.disabled) {
					if (node.attributes.gid) {
						pars += '&gids[]='+node.attributes.gid;
					} else {
						pars += '&uids[]='+node.attributes.uid;
					}
				}
			});
		
			Ext.Ajax.request({
				url: URLRoot+'/?module=folder_options&section=ajax&page=save',
				method: 'post', params: pars,
				success: function(req){
					try {
						var rs = Ext.util.JSON.decode(req.responseText);
					} catch (er){return false;}
					if (rs.rs) {
						iconEl = window.parent.Ext.get(window.parent.FR.UI.tree.sharingNode.getUI().getIconEl());
						if (rs.isHidden) {} else {}
						FR.popup.hide();
					}
					window.parent.FR.UI.feedback(rs.msg);
				}
			});
		
		}
	});
	
	FR.UI.tree.panel = new Ext.tree.TreePanel({
		tbar: tb, bbar: bb, border: false, hideBorders: true,
	    animate: true, containerScroll: true, rootVisible:false
	});
	FR.UI.tree.panel.getSelectionModel().on('selectionchange', function(sel, node){
		if (sel.getSelectedNode()) {
			FR.removeBtn.enable();
		} else {
			FR.removeBtn.disable();
		}
	});
	FR.UI.tree.rootNode = new Ext.tree.TreeNode({
		text: 'Root', cls:'album-node', iconCls:'folder'
	});
	FR.UI.tree.panel.setRootNode(FR.UI.tree.rootNode);
	
	var vp = new Ext.Viewport({
		layout: 'border', hideBorders: true,
		items: [
			{
				region: 'center', layout: 'fit',
				title: FR.T('Hide folder for certain users'),
				items: [FR.UI.tree.panel]
			}
		]
	});
	FR.removeBtn = FR.UI.tree.panel.getTopToolbar().items.map['removeBtn'];
	FR.addUsersBtn = FR.UI.tree.panel.getTopToolbar().items.map['addUsersBtn'];
	FR.applyInfo(FR.folderInfo);
});
FR.getInfo = function () {
	FR.popupBody.mask(FR.T('Loading data...'));
	Ext.Ajax.request({
		url: URLRoot+'/?module=folder_options&section=ajax&page=load', 
		method: 'post',
		params: 'path='+encodeURIComponent(window.parent.FR.currentFolderOptionsPath),
		success: function(req){									
			FR.popupBody.unmask();
			try {
				var rs = Ext.util.JSON.decode(req.responseText);
			} catch (er){return false;}
			FR.applyInfo(rs);
		}
	});
}
FR.addToList = function(data) {
	var newTreeNode = new Ext.tree.TreeNode(data);
	FR.UI.tree.rootNode.appendChild(newTreeNode);
	if (!FR.UI.tree.panel.getSelectionModel().getSelectedNode()) {
		newTreeNode.select();
	}
}
FR.applyInfo = function (info) {
	treeRoot = FR.UI.tree.rootNode;
	while (treeRoot.firstChild) {treeRoot.removeChild(treeRoot.firstChild);}
	Ext.each(info, function(record) {
		FR.addToList({
			name: record.name, text: record.name, leaf: true,
			cls: record.uid ? 'user':'group',
			iconCls: record.uid ? 'user':'group',
			uid: record.uid ? record.uid : false,
			gid: record.gid ? record.gid : false
		});
	});
	if (treeRoot.childNodes.length > 0) {treeRoot.firstChild.select();}
}