Ext.onReady(function() {
	var runtimes = '';
	if (Ext.isSafari || Ext.isIE) {
		runtimes = 'flash,silverlight,gears,browserplus,html5,html4';
	} else if (Ext.isGecko || Ext.isChrome) {
		runtimes = 'html5,flash,silverlight,gears,browserplus,html4';
	} else {
		runtimes = 'html5,flash,silverlight,gears,browserplus,html4';
	}
	new Ext.Viewport({
		layout: 'border', border: false,
		items: {
			region: 'center', layout: 'fit', border: false,
			items: {
				id: 'PluploadPanel',
				xtype: 'pluploadpanel',
				border: false,
				addButtonCls: 'silk-add',
				uploadButtonCls: 'silk-arrow-up',
				cancelButtonCls: 'silk-stop',
				deleteButtonCls: 'silk-cross',
				
				addButtonText: FR.T('Select Files'),
				uploadButtonText: FR.T('Upload'),
				cancelButtonText: FR.T('Cancel Upload'),
				deleteButtonText: FR.T('Remove'),
				deleteSelectedText: '<b>'+FR.T('Remove selected')+'</b>',
				deleteUploadedText: FR.T('Remove uploaded'),
				deleteAllText: FR.T('Remove all'),
				
				statusQueuedText: FR.T('Queued'),
				statusUploadingText: FR.T('Uploading ({0}%)'),
				statusFailedText: '<span style="color: red">'+FR.T('Failed')+'</span>',
				statusDoneText: '<span style="color: green">'+FR.T('Done')+'</span>',
				
				statusInvalidSizeText: FR.T('Too big'),
				statusInvalidExtensionText: FR.T('Invalid file type'),
				
				emptyText: '<div class="plupload_emptytext"><table cellpadding="0" cellspacing="0" border="0" style="width:100%;height:240px;"><tr align="center"><td align="center"><span style="font-size:15px;color:#a1a1a1;">'+FR.T('Click "Select Files"')+'</span></td></tr></table></div>',
				emptyDropText: '<div class="plupload_emptytext"><table cellpadding="0" cellspacing="0" border="0" style="width:100%;height:240px;"><tr align="center"><td align="center"><span style="font-size:15px;color:#a1a1a1;">'+FR.T('Drag files from your computer here<br>or click "%1"').replace('%1', FR.T('Select Files'))+'</span></td></tr></table></div>',
				
				progressText: FR.T('{2} of {1} uploaded ({5}/s)'),
				
				listeners: {
					beforestart: function(p) {
						p.uploader.settings.url = postURL+'&runtime='+p.runtime;
						p.uploader.settings.multipart_params = {path: window.parent.FR.currentPath};
					},
					uploadstarted: function(p) {
					},
					uploadcomplete: function(p, success, failures) {
						if (success.length && !failures.length) {
							with (window.parent) {
								FR.UI.uploadDialog.hide();
								FR.utils.reloadGrid();
								FR.UI.reloadStatusBar();
							}
						}
					},
					chunkuploaded: function(p, up, file, info) {
						try {
							var rs = Ext.util.JSON.decode(info.response);
						} catch (er){return false;}
						if (!rs.success) {
							up.stop();
							Ext.MessageBox.show({
								icon: Ext.MessageBox.WARNING,
								title: Ext.util.Format.htmlEncode(file.name),
								closable: false, width: 300,
								msg: rs.msg,
								buttons: Ext.MessageBox.OK
							});
						}
					},
					fileuploaded: function(p, up, file, rs, status) {
						if (!rs.success) {
							up.stop();
							if (rs.msg) {
								Ext.MessageBox.show({
									icon: Ext.MessageBox.WARNING,
									title: Ext.util.Format.htmlEncode(file.name),
									closable: false, width: 300,
									msg: rs.msg,
									buttons: Ext.MessageBox.OK
								});
							}
						}
					}
				},
				runtimes: runtimes,
				multipart: true,
				urlstream_upload: true,
				url: postURL,
				flash_swf_url: 'js/plupload/plupload.flash.swf',
				silverlight_xap_url: 'js/plupload/plupload.silverlight.xap',
				chunk_size: chunkSize,
				max_file_size: '3900m'
			}
		}
	});
});