Ext.onReady(function() {
	Ext.QuickTips.init();
	treeLoader = new Ext.ux.tree.TreeGridLoader({
		dataUrl: URLRoot+'/?module=pop_importer&section=ajax&page=tree',
		uiProviders: {'col': Ext.tree.ColumnNodeUI}
	});
	treeLoader.on('beforeload', function(loader, node){
		loader.baseParams.accountId = node.attributes.accountId;
	});
	treeLoader.on('load', function(loader, node, response) {
		try {
			rs = Ext.util.JSON.decode(response.responseText);
		} catch (er){
			node.collapse();
			node.loaded = false;
			Ext.MessageBox.alert('', response.responseText);
			return false;
		}
		if (rs.error) {
			node.collapse();
			node.loaded = false;
			Ext.MessageBox.alert('', rs.error);
		}
	});
	FR.addAccountWin = false;
	Ext.get('theBODY').on('mousemove', function(e){FR.UI.xy = e.getXY();});
	FR.tree = new Ext.ux.tree.TreeGrid({
		width: 384,
		border: false, autoHeight: true, enableSort: false, enableHdMenu: false, columnResize: false,
		renderTo: Ext.getBody(),
		tbar: [
			{
				text: FR.T('Add Account'),
				icon: URLRoot+'/images/fileman/interface/icons/world_add.gif',
				cls: 'x-btn-text-icon',
				handler: function() {
					if(!FR.addAccountWin){
						FR.addAccountForm = new Ext.FormPanel({
							url: URLRoot+'/?module=pop_importer&section=ajax&page=add_account',
							border: false,
							bodyStyle: 'padding: 5px;',
							defaultType: 'textfield',
							items: [{
									fieldLabel: FR.T('Account title'),
									name: 'title',
									allowBlank:false,
									value: FR.T('My E-mail Account')
								},{
									fieldLabel: FR.T('Server'),
									name: 'server',
									allowBlank:false
								},{
									fieldLabel: FR.T('Server port'),
									name: 'port',
									value: '110',
									allowBlank:false
								},{
									xtype: 'checkbox',
									fieldLabel: FR.T('Use SSL'),
									name: 'ssl',
									value: '1'
								},{
									fieldLabel: FR.T('Username'),
									name: 'username',
									allowBlank: false
								}, {
									fieldLabel: FR.T('Password'),
									inputType : 'password',
									name: 'password'
								}
							]
						});
						FR.addAccountWin = new Ext.Window({
							title: FR.T('Add E-mail Account'),
							width:285, height:235, constrain: true,
							closeAction:'hide', layout: 'fit',
							items: FR.addAccountForm,
							buttons: [{
								text: FR.T('Save'),
								handler: function() {
									FR.addAccountForm.getForm().submit({
										success: function(frm, action) {
											FR.addAccountWin.hide();
											node = new Ext.tree.AsyncTreeNode({
												text: action.result.title,
												iconCls: 'email-account',
												loader: treeLoader,
												listeners: {'beforecollapse': function(node, e){node.loaded=false;}}
											});
											node.attributes.title = action.result.title;
											node.attributes.accountId = action.result.id;
											FR.tree.getRootNode().appendChild(node);
											node.select();
										},
										failure: function(frm, action) {
											if (action.result && action.result.msg) {
												Ext.MessageBox.alert('', 'Error: '+action.result.msg);
											}
										}
									});
								}
							},{
								text: FR.T('Cancel'),
								handler: function() {FR.addAccountWin.hide();}
							}]
						});
					}
				FR.addAccountWin.show(this);
				}
			},
			{
				text: FR.T('Remove Account'),
				id: 'removeAccountBtn',
				icon: URLRoot+'/images/fileman/interface/icons/world_delete.gif',
				cls: 'x-btn-text-icon',
				disabled: true,
				handler: function() {
					FR.deletingNode = FR.tree.getSelectionModel().getSelectedNode();
					Ext.Ajax.request({
							url : URLRoot+'/?module=pop_importer&section=ajax&page=delete_account',
							params: {accountId: FR.deletingNode.attributes.accountId},
							success: function ( result, request ) {
								var rs = eval('('+result.responseText+')');
								if (!rs.rs) {
									Ext.MessageBox.alert('', rs.msg);
								} else {
									FR.tree.getRootNode().removeChild(FR.deletingNode);
								}
							}
						});
				}
			}
		],
		columns:[{
			header: FR.T('Account/Subject'),
			dataIndex: 'title',
			width: 230
		},{
			header: FR.T('From'),
			dataIndex:'from',
			width: 150
		}],
		autoExpandColumn: 'filename',
		loader: treeLoader,
		root: new Ext.tree.AsyncTreeNode({
			text:'Root',
			children: treeData
		})
	});
	var menu = new Ext.menu.Menu({
		id: 'contextmenu',
		items: [
			{
				text: FR.T('Import attachments'),
				icon: URLRoot+'/images/fileman/interface/icons/link_go.gif',
				handler: function() {
					Ext.Ajax.request({
							url : URLRoot+'/?module=pop_importer&section=ajax&page=import',
							params: {
								path: window.parent.FR.currentPath,
								accountId: FR.selectedNode.attributes.accountId,
								msgNo: FR.selectedNode.attributes.msgNo
							},
							success: function (response) {
								var rs = eval('('+response.responseText+')');
								Ext.MessageBox.alert('', rs.msg);
								if (rs.rs) {
									window.parent.FR.utils.reloadGrid();
								}
							}
						});
				}
			},
			{
				text: FR.T('Discard message'),
				icon: URLRoot+'/images/fileman/interface/icons/email_delete.gif',
				handler: function() {
					FR.deletingNode = FR.tree.getSelectionModel().getSelectedNode();
					Ext.Ajax.request({
						url : URLRoot+'/?module=pop_importer&section=ajax&page=discard',
						params: {
							accountId: FR.selectedNode.attributes.accountId,
							msgId: FR.selectedNode.attributes.msgId
						},
						success: function (response) {
							var rs = eval('('+response.responseText+')');
							Ext.MessageBox.alert('', rs.msg);
							if (rs.rs) {
								FR.tree.getRootNode().removeChild(FR.deletingNode);
							}
						}
					});
				}
			}
		]
	});
	FR.tree.on('contextmenu', function(node, e){
		if (!node.isSelected()) {node.select();}
		FR.selectedNode = node;
		if (node.attributes.msgNo) {
			menu.showAt([FR.UI.xy[0]+3, FR.UI.xy[1]+3]);
		}
	});
	FR.tree.getSelectionModel().on('selectionchange', function(selModel, node){
		selNode = selModel.getSelectedNode();
		if (selNode) {
			if (!selNode.attributes.msgNo) {
				Ext.getCmp('removeAccountBtn').enable();
			} else {
				Ext.getCmp('removeAccountBtn').disable();
			}
		}
	});
});