var UserChooser = function(config){
	this.config = config || {};
	this.config.url = URLRoot+'/?module=fileman&section=utils&page=user_chooser_tree';
	this.initTree();
	ths = this;
    var dlg = new Ext.Window({
		id: this.config.id || Ext.id(),
		closeAction: 'hide',
		resizable:false, width: 250, height: 250,
		title: FR.T('Select Users'),
		layout: 'border',
		hideBorders: true,
		modal: true,
		tools: [
			{
				id: 'search',
				handler: function() {
					Ext.getCmp(ths.config.id+'-north-region').show();
					Ext.getCmp(ths.config.id+'-north-region').ownerCt.doLayout();
				}
			}
		],
        items: [
			{
				region: 'north',
				layout: 'fit',
				height: 22,
				border:false, hideBorders: true,
				id: ths.config.id+'-north-region',
				items: [
				{
					xtype: 'trigger',
					id: ths.config.id+'-search',
					triggerClass: 'x-form-clear-trigger',
					emptyText: window.parent.FR.T('Search'),
					onTriggerClick:function() {
						var val = this.getRawValue();
						if (val != '') {
							this.setValue('');
							r.loaded = false;
							r.collapse();
							r.expand();
						}
						//Ext.getCmp(ths.config.id+'-north-region').collapse();
						Ext.getCmp(ths.config.id+'-north-region').hide();
						Ext.getCmp(ths.config.id+'-north-region').ownerCt.doLayout();
					},
					enableKeyEvents: true,
					listeners:{
						keyup: {
							buffer: 500, 
							fn: function(field, e) {
								if(Ext.EventObject.ESC == e.getKey()) {
									field.onTriggerClick();
								} else {
									r.loaded = false;
									r.collapse();
									r.expand();
								}
							}
						}
					}
				}]
			},
			{
				region: 'center',
				layout: 'fit',
				bbar: [
					{
						xtype: 'tbbutton',
						cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/tick.gif',
						text: FR.T('Ok'),
						handler: ths.doCallback,
						scope: ths
					},
					{
						xtype: 'tbbutton',
						cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/cross.gif',
						text: FR.T('Cancel'),
						handler: function () {
							this.dlg.hide()
						},
						scope: ths
					}
				],
				items: this.tree
			}
		]
	});
	this.dlg = dlg;
};
UserChooser.prototype = {
	initTree : function() {
		t = new Ext.tree.TreePanel({
		    animate: true,
		    containerScroll: true,
			rootVisible: false,
			bodyBorder: false,
			autoScroll: true
		});
		r = new Ext.tree.AsyncTreeNode({
			text: 'Root',
			gid:'',
			loader: new Ext.tree.TreeLoader({
				dataUrl: this.config.url,
				requestMethod: 'GET',
				baseAttrs: {checked: false}
			})
		});
		t.setRootNode(r);
		r.attributes.loader.on({
			beforeload: function() {t.el.mask(window.parent.FR.T('Loading...'));},
			load: function() {t.el.unmask();},
			loadexception: function() {t.el.unmask();}
		});
		ths = this;
		r.attributes.loader.on('beforeload', function(loader, node){
			if (node.attributes.gid && node.attributes.countUsers > 200) {
				alert('You choose to browse a group with '+node.attributes.countUsers+' users. The loading will take a while, please wait.');
			}
		loader.baseParams.gid = node.attributes.gid;
		loader.baseParams.showSelf = (ths.config.showSelf ? 1 : 0);
		loader.baseParams.search = Ext.getCmp(ths.config.id+'-search').getRawValue();
		});
		this.tree = t;
	},
	show : function(el, callback){
	    this.dlg.show(el);
		Ext.getCmp(ths.config.id+'-north-region').hide();
		window.setTimeout(function() {
		Ext.getCmp(ths.config.id+'-north-region').ownerCt.doLayout();
		}, 500);
		this.callback = callback;
	},
	clearChecked: function() {
		this.tree.getRootNode().cascade(function(n) {
	        var ui = n.getUI();
	        ui.toggleCheck(false);
	    });
	},
	doCallback : function() {
		var data = {users:[], groups:[]};
		Ext.each(this.tree.getChecked(), function(node) {
			var type = node.attributes.uid ? 'users' : 'groups';
			var id = node.attributes.uid ? node.attributes.uid : node.attributes.gid;
			if (type == 'groups' && id == '-') {
				//skip "unsorted users" item
			} else {
				data[type].push(node.attributes);
			}
		});
		this.callback(data);
		this.dlg.hide();
	}
};