Ext.onReady(function() {
	var ds = new Ext.data.Store({
	  proxy: new Ext.data.MemoryProxy(gridData),
	  reader: new Ext.data.ArrayReader({}, [
			{name: 'version'},
			{name: 'date', type: 'date', dateFormat: 'timestamp'},
			{name: 'user'}
		])
	});
	ds.load();
	var colModel = new Ext.grid.ColumnModel([
		{id:'version', header: FR.T("Version"), width:60, dataIndex: 'version'},
		{id:'date', header: FR.T("Date"), renderer: Ext.util.Format.dateRenderer(FR.T('Date Format: Grid - Date')), width:100, dataIndex: 'date'},
		{header: FR.T("Modified by"), width:100, dataIndex: 'user'}
	]);
	var grid = new Ext.grid.GridPanel({
	    ds: ds,
	    cm: colModel,
		enableHdMenu: false,
		border: false,
	 	selModel: new Ext.grid.RowSelectionModel({
			singleSelect:true
		}),
		autoExpandColumn: 'date'
	});

	grid.on('rowcontextmenu', function(grid, rowIndex, e) {versioningOnContextMenu(grid, rowIndex, e);});
	if (Ext.isMac) {
		grid.on('rowclick', function(grid, rowIndex, e) {versioningOnContextMenu(grid, rowIndex, e);});
	}
	gridContextMenu = new Ext.menu.Menu({
	    id: 'contextmenu',
	    items: []
	});
	if (window.parent.User.perms.download) {
		gridContextMenu.add(new Ext.menu.Item({text: FR.T('Download'), handler: function() {
			var selection = grid.getSelectionModel().getSelections();
			document.location.href = URLRoot+'/?module=fileman_myfiles&section=ajax&page=download&path='+encodeURIComponent(currentPath)+'&filename='+encodeURIComponent(currentFilename)+'&version='+selection[0].data.version;
		},
		icon: URLRoot+'/images/fileman/interface/icons/disk.gif'
		}));
	}
	if (!window.parent.User.perms.read_only) {
		gridContextMenu.add(new Ext.menu.Item({text: FR.T('Restore'), handler: function() {
				var selection = grid.getSelectionModel().getSelections();
				var url = URLRoot+'/?module=versioning&section=ajax&page=actions&action=restore&version='+selection[0].data.version;
				var pars = 'path='+encodeURIComponent(currentPath)+'&filename='+encodeURIComponent(currentFilename);
				Ext.Ajax.request({
					url: url,
					method: 'post',
					params: pars,
					success: function(req){
						try {
							var rs = Ext.util.JSON.decode(req.responseText);
						} catch (er){return false;}
						if (rs.rs) {}
						Ext.Msg.alert('', rs.msg);
					}
				});
			},
			icon: URLRoot+'/images/fileman/interface/icons/thumb_up.gif'
		}));
		gridContextMenu.add(new Ext.menu.Item({text: FR.T('Delete'), handler: function() {
				var selection = grid.getSelectionModel().getSelections();
				var url = URLRoot+'/?module=versioning&section=ajax&page=actions&action=delete&version='+selection[0].data.version;
				var pars = 'path='+encodeURIComponent(currentPath)+'&filename='+encodeURIComponent(currentFilename);
				Ext.Ajax.request({
					url: url,
					method: 'post',
					params: pars,
					success: function(req){
						try {
							var rs = Ext.util.JSON.decode(req.responseText);
						} catch (er){return false;}
						if (rs.rs) {
							grid.getStore().remove(grid.getSelectionModel().getSelected());
						}
						Ext.Msg.alert('', rs.msg);
					}
				});
			},
			icon: URLRoot+'/images/fileman/interface/icons/cross.gif'
		}));
	}
	var viewport = new Ext.Viewport({
		layout: 'border',
		hideBorders: true,
		items: [
			{
				region: 'center',
				layout: 'fit',
				items: grid
			}
		]
	});
	Ext.EventManager.addListener(viewport.getEl(), 'contextmenu', function(e) {
		e.stopEvent();
	});
});
versioningOnContextMenu = function(grid, rowIndex, e) {
	if (!window.parent.User.perms.read_only) {
		grid.selModel.selectRow(rowIndex);
		gridContextMenu.showAt(e.getXY());
	}
	e.stopEvent();
	return false;
}