Ext.onReady(function() {
	FR.update = function(args) {
		FR.email = args.email;
		FR.getInfo();
	}
	var labelWidth = ((FR.language == 'german')?205:170);
	var fieldWidth = ((FR.language == 'german')?150:180);
	FR.UI.form = new Ext.FormPanel({
		autoHeight: true, border: false,
		defaultType: 'textfield',
		labelAlign: 'right', labelWidth: labelWidth,
		bodyStyle: 'padding-top:10px;padding-left:10px;',
		defaults: {width: fieldWidth, labelStyle: 'white-space:nowrap'},
		items: [
			{
	            fieldLabel: FR.T('Expiration date'),
				name: 'expiry', xtype: 'datefield', id: 'expiry', minValue: new Date()
	        },
			{
	            fieldLabel: FR.T('Download limit'),
				name: 'download_limit', id: 'download_limit', width: 50
	        },
			{
	            fieldLabel: FR.T('Set a password'),
				name: 'password', id: 'password'
	        },
			{
	            fieldLabel: FR.T('Allow visitors to upload files'),
				xtype: 'checkbox', name: 'allow_uploads', id: 'allow_uploads', value: '1'
	        },
			{
	            fieldLabel: FR.T('Receive e-mail notifications'),
				xtype: 'checkbox', name: 'notify', id: 'notify', value: '1'
	        }
		]
    });
	FR.viewport = new Ext.Viewport({
		layout: 'border', border: false,
		items: [
			{
				region: 'center', layout: 'fit', border: false,
				items: [FR.UI.form],
				bbar: [
					{
						id: 'emailBtn',
						text: FR.T('E-mail'), cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/email_attach.gif',
						handler: function(){
							FR.emailLink((FR.WebLinkInfo.short_url ? FR.WebLinkInfo.short_url : FR.WebLinkInfo.url));
						}
					},
					'->',
					{
						id: 'createBtn',
						text: FR.T('Create Web Link'), cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/world_link.gif',
						handler: function(){FR.createOrSave('create');}
					},
					{
						id: 'saveBtn',
						text: FR.T('Update Settings'), cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/disk.gif',
						handler: function(){FR.createOrSave('edit');}
					},
					{
						id: 'removeBtn',
						text: FR.T('Remove Web Link'), cls: 'x-btn-text-icon',
						icon: URLRoot+'/images/fileman/interface/icons/cross.gif',
						handler: function() {
							var url = URLRoot+'/?module=weblinks&section=ajax&page=update&action=remove';
							FR.loadMask.show();
							Ext.Ajax.request({
								url: url,
								method: 'post',
								params: {
							        path: window.parent.FR.WebLinking.path
							    },
								success: function(req){
									FR.loadMask.hide();
									try {
										var rs = Ext.util.JSON.decode(req.responseText);
									} catch (er){return false;}
									if (rs.success) {
										with (window.parent) {
											if (FR.WebLinking.item) {
												if (FR.WebLinking.item.attributes) {
													FR.WebLinking.item.attributes.custom.weblink = 0;
													FR.UI.tree.updateIcon(FR.WebLinking.item);
												}
											}
										}
										FR.switchPanels(0);
									} else {
										 Ext.Msg.alert('', rs.msg);
									}
								}
							});
						}
					}
				]
			},
			{
				
				region: 'south', layout: 'fit', id: 'southReg',
				height: 120, border: false,
				bodyStyle: 'border-top:1px solid #D0D0D0',
				items: [
					{
						id: 'noLinkPanel', border: false,
						html: '<div style="margin-top:45px;color:gray;text-align:center;">'+FR.T('This file is currently not linked')+'.</div>'
					},
					{
						id: 'URLPanel',
						xtype: 'form', border: false, hidden: true, autoHeight: true,
						defaultType: 'textfield',
						bodyStyle: 'padding-top:8px;padding-left:10px;',
						items: [
							{
							    xtype: 'component',
							    autoEl: {html: '<div class="x-form-item">'+FR.T('Link address')+':</div>'}
							},
							{
								id: 'LinkURLField',
								hideLabel: true, width: 355,
								labelSeparator: '',
								selectOnFocus: true
							},
							{
							    xtype: 'component',
							    autoEl: {html: '<div class="x-form-item">'+FR.T('Short address')+':</div>'}
							},
							{
								id: 'ShortLinkURLField',
								hideLabel: true, width: 355,
								labelSeparator: '',
								emptyText: FR.T('- click to generate -'),
								listeners: {
									'focus': function(field) {
										if (field.getValue() == '') {
											field.setValue(FR.T('Loading...'));
											var url = URLRoot+'/?module=weblinks&section=ajax&page=get_short';
											Ext.Ajax.request({
												url: url,
												method: 'post',
												params: {linkId: FR.WebLinkInfo.id},
												success: function(req){
													try {
														var rs = Ext.util.JSON.decode(req.responseText);
													} catch (er){return false;}
													if (rs.success) {
														FR.WebLinkInfo.short_url = rs.url;
														field.setValue(rs.url);
														field.focus(true);
													} else {
														field.setValue('Error: '+rs.error);
													}
												}
											});
										}
									}
								}
							}
						]
					}
				]
			}
		]
	});
	FR.createOrSave = function(act) {
		FR.loadMask.show();
		FR.UI.form.getForm().submit({
			clientValidation: true,
			url: URLRoot+'/?module=weblinks&section=ajax&page=update&action='+act,
			params: {
				path: window.parent.FR.WebLinking.path
			},
			success: function(form, action) {
				FR.loadMask.hide();
				FR.switchPanels(1);
				if (act == 'create') {
					FR.WebLinkInfo = action.result;
					Ext.getCmp('LinkURLField').setValue(action.result.url);
					Ext.getCmp('ShortLinkURLField').setValue('');
					if (FR.email) {
						FR.emailLink((action.result.short_url ? action.result.short_url : action.result.url));
					}
					with (window.parent) {
						if (FR.WebLinking.item) {
							if (FR.WebLinking.item.attributes) {
								FR.WebLinking.item.attributes.custom.weblink = 1;
								FR.UI.tree.updateIcon(FR.WebLinking.item);
							}
						}
					}
				} else {
					window.parent.FR.UI.feedback(action.result.msg);
				}
			},
			failure: function(form, action) {
				FR.loadMask.hide();
				switch (action.failureType) {
					case Ext.form.Action.CLIENT_INVALID:
						Ext.Msg.alert('', FR.T("Please make the appropriate <br>changes to the highlighted fields."));break;
					case Ext.form.Action.CONNECT_FAILURE:
						Ext.Msg.alert('', "Ajax communication failed.");break;
					case Ext.form.Action.SERVER_INVALID:
						Ext.Msg.alert('', action.result.msg);
				}
			}
		});
	}
	FR.getInfo = function () {
		window.parent.Ext.get(window.parent.FR.UI.popups.webLink.getLayout().container.body.dom).mask(FR.T('Loading data...'));
		var url = URLRoot+'/?module=weblinks&section=ajax&page=load'+(FR.email ? '&email=1' : '');
		var pars = 'path='+encodeURIComponent(window.parent.FR.WebLinking.path);
		Ext.Ajax.request({
			url: url, 
			method: 'post',
			params: pars,
			success: function(req){
				window.parent.Ext.get(window.parent.FR.UI.popups.webLink.getLayout().container.body.dom).unmask();
				try {
					var rs = Ext.util.JSON.decode(req.responseText);
				} catch (er){return false;}
				Ext.getCmp('allow_uploads').setVisible(rs.isdir);
				Ext.getCmp('download_limit').setVisible(!rs.isdir);
				FR.viewport.doLayout();
				if (rs.linkInfo) {
					FR.WebLinkInfo = rs.linkInfo;
					Ext.getCmp('expiry').setValue(rs.linkInfo.expiry2);
					Ext.getCmp('download_limit').setValue(rs.linkInfo.download_limit);
					Ext.getCmp('password').setValue(rs.linkInfo.password);
					Ext.getCmp('LinkURLField').setValue(rs.linkInfo.url);
					Ext.getCmp('ShortLinkURLField').setValue(rs.linkInfo.short_url);
					Ext.getCmp('allow_uploads').setValue((rs.linkInfo.allow_uploads == '1'));
					Ext.getCmp('notify').setValue((rs.linkInfo.notify == '1'));
					FR.switchPanels(1);
					if (FR.email) {
						FR.emailLink((rs.linkInfo.short_url ? rs.linkInfo.short_url : rs.linkInfo.url));
					}
				} else {
					FR.UI.form.getForm().reset();
					Ext.getCmp('LinkURLField').setValue('');
					FR.switchPanels(0);
				}
			}
		});
	}
	FR.switchPanels = function(toggle) {
		Ext.getCmp('noLinkPanel').setVisible(!toggle);
		Ext.getCmp('URLPanel').setVisible(toggle);
		Ext.getCmp('createBtn').setVisible(!toggle);
		Ext.getCmp('saveBtn').setVisible(toggle);
		Ext.getCmp('removeBtn').setVisible(toggle);
		Ext.getCmp('emailBtn').setVisible(toggle);
	}
	FR.emailLink = function(url) {
		document.location.href = 'mailto:?body='+encodeURIComponent(url);
	}
	window.parent.Ext.get(window.parent.FR.UI.popups.webLink.getLayout().container.body.dom).unmask();
	FR.loadMask = new Ext.LoadMask(Ext.get('southReg'), {msg: window.parent.FR.T('Loading...')});
	FR.update({email: FR.email});
});