FileRun.controllers.FileList = new Ext.Controller({
	'launch': function() {
		FileRun.stores.FileList.on('load', function(store, r, s) {
			FileRun.views.FileList.list.scroller.scrollTo({x: 0, y: 0});
			if (s) {
				var data = store.getProxy().getReader().jsonData;
				if (data.error) {
					Ext.Msg.alert(FR.T('Error'), data.error);
				}
				FR.parentPath = data.parentPath;
				FR.currentPath = data.path;
				FR.currentFolder = data.folderName;
				FileRun.controllers.FileList.updateTitle();
				FR.UI.buttons.folderBack.setVisible((FR.currentPath != '/ROOT/HOME'));
			}
		});
		FileRun.views.FileList.list.on('selectionchange', function(selModel, r) {
			var sel = selModel.getSelection();
			var sel = sel[0];
			if (sel) {
				selModel.deselect(sel);
				if (sel.data.dir) {
					Ext.dispatch({
						controller: this,
						action: 'chDir',
						path: FR.currentPath+'/'+encodeURIComponent(sel.data.n)
					});
				} else {
					Ext.dispatch({
						controller: FileRun.controllers.FilePanel,
						action: 'load',
						file: sel.data
					});
				}
			}
		}, this);
		FileRun.stores.FileList.load();
	},
	'updateTitle': function() {
		if (FR.currentPath == '/ROOT/HOME') {
			var title = Settings.title;
		} else {
			var title = FR.currentFolder;
		}
		FileRun.views.FileList.down('.toolbar').setTitle(title);
	},
	'chDir': function(opt) {
		FileRun.stores.FileList.load({params: {path: opt.path}});
	},
	'reload': function(opt) {
		Ext.dispatch({
			controller: this,
			action: 'chDir',
			path: FR.currentPath
		});
	},
	'showUploadForm': function(opt) {
		if (!FileRun.views.UploadForm) {
			FileRun.views.UploadForm = new FileRun.views.UploadFormV();
		}
		FileRun.views.UploadForm.showBy(opt.button);
	}
});