FileRun.controllers.FilePanel = new Ext.Controller({
	'load': function(opt) {
		FR.currentFile = opt.file;
		if (!FileRun.views.FilePanel) {
			FileRun.views.FilePanel = new FileRun.views.FilePanelV();
			FileRun.views.viewport.insert(1, FileRun.views.FilePanel);
			FileRun.views.viewport.doLayout();
		}
		FileRun.views.FilePanel.down('.toolbar').setTitle(FR.currentFile.n);
		var file = Ext.ModelMgr.create(FR.currentFile, 'File');
		FileRun.views.FilePanel.formPanel.load(file);
		if (FR.currentFile.th != '') {
			FR.UI.buttons.preview.show();
		} else {
			FR.UI.buttons.preview.hide();
		}
		FR.UI.buttons.openWith.setVisible((FR.ext[FR.currentFile.x]));
		FileRun.views.FilePanel.moreMenu.doLayout();
		FileRun.views.viewport.getLayout().next();
	},
	'backToList': function() {
		FileRun.views.viewport.getLayout().prev({type: 'slide', direction: 'right'});
	},
	'download': function() {
		var url = '../?module=fileman&section=touch&page=download&path='+encodeURIComponent(FR.currentPath);
		url += '&filename='+encodeURIComponent(FR.currentFile.n);
		document.location.href = url;
	},
	'preview': function() {
		var s = FileRun.views.viewport.getSize();
		var w = (parseInt(s.width)-(20/100*s.width));
		var h = (parseInt(s.height)-(20/100*s.height));
		var thumbURL = '../?module=fileman_myfiles&section=ajax&page=thumbnail&path='+encodeURIComponent(FR.currentPath);
		thumbURL += '&filename='+encodeURIComponent(FR.currentFile.n)+'&filesize='+encodeURIComponent(FR.currentFile.s)
		thumbURL += '&mtime='+encodeURIComponent(FR.currentFile.m)+'&naturalSize=1';
		thumbURL += '&width='+w;
		thumbURL += '&height='+h;

		var wrap = Ext.getBody().createChild({tag: "div", style: "text-align:center;"});
		var p = new Ext.Panel({
			floating: true,
			fullscreen: true,
			modal: true,
			centered: true,
			styleHtmlContent: true,
			scroll: 'vertical',
			contentEl: wrap,
			dockedItems: [{
				xtype: 'toolbar',
				title: FR.currentFile.n,
				items: [
					{xtype: 'spacer'},
					{xtype: 'button', text: FR.T('Close'), handler: function() {this.up('panel').hide();}}
				]
			}]
		});
		p.show('pop');
		p.setLoading(true, true);
		var image = wrap.createChild({tag: "img", src: thumbURL});
		image.hide();
		image.on("load", function() {
			image.show('fade');
			p.setLoading(false);
		});
		
	},
	'getWebLink': function(opt) {
		opt.btn.up('panel').hide();
		FileRun.views.FilePanel.setLoading(true, true);
		var url = '../?module=weblinks&section=ajax&page=update&action=create';
		Ext.Ajax.request({
			url: url,
			params: {path: FR.currentPath+'/'+FR.currentFile.n},
			success: function(response, opts) {
				FileRun.views.FilePanel.setLoading(false);
				var rs = Ext.decode(response.responseText);
				if (rs.success) {
					//aici scrie modificarea si in FileList store
					FileRun.views.FilePanel.formPanel.getFields().wl.setValue(rs.url);
				} else {
					Ext.Msg.alert(FR.T('WebLink'), rs.msg);
				}
			}
		});
	},
	'removeWebLink': function(opt) {
		FileRun.views.FilePanel.setLoading(true, true);
		var url = '../?module=weblinks&section=ajax&page=update&action=remove';
		Ext.Ajax.request({
			url: url,
			params: {path: FR.currentPath+'/'+FR.currentFile.n},
			success: function(response, opts) {
				FileRun.views.FilePanel.setLoading(false);
				var rs = Ext.decode(response.responseText);
				if (rs.success) {
					FileRun.views.FilePanel.formPanel.getFields().wl.setValue('');
					Ext.Msg.alert(FR.T('WebLink'), rs.msg);
				}
			}
		});
	},
	'ren': function(opt) {
		FileRun.views.FilePanel.setLoading(true, true);
		var url = '../?module=fileman_myfiles&section=ajax&page=grid_action_rename';
		var newName = opt.newName;
		Ext.Ajax.request({
			url: url,
			params: {
				path: FR.currentPath,
				oldfilename: FR.currentFile.n,
				newfilename: newName
			},
			success: function(response, opts) {
				FileRun.views.FilePanel.setLoading(false);
				var rs = Ext.decode(response.responseText);
				if (rs) {
					Ext.Msg.alert(FR.T('Rename'), rs.msg);
					FR.currentFile.n = newName;
					Ext.dispatch({
						controller: FileRun.controllers.FileList,
						action: 'reload'
					});
				}
			}
		});
	},
	'del': function(opt) {
		opt.btn.up('panel').hide();
		Ext.Msg.confirm(FR.T('Delete'), FR.T('Are you sure you want to delete the selected file?'), function(btn) {
			if (btn == 'yes') {
				FileRun.views.FilePanel.setLoading(true, true);
				var url = '../?module=fileman_myfiles&section=ajax&page=grid_action_delete';
				var params = 'path='+encodeURIComponent(FR.currentPath);
				params += '&filenames[]='+encodeURIComponent(FR.currentFile.n);
				Ext.Ajax.request({
					url: url,
					params: params,
					success: function(response, opts) {
						FileRun.views.FilePanel.setLoading(false);
						var rs = Ext.decode(response.responseText);
						if (rs.rs) {
							Ext.dispatch({
								controller: FileRun.controllers.FilePanel,
								action: 'backToList'
							});
							Ext.dispatch({
								controller: FileRun.controllers.FileList,
								action: 'reload'
							});
						} else {
							Ext.Msg.alert(FR.T('Delete'), rs.msg);
						}
					}
				});
			}
		});
	}
});