FileRun.controllers.app = new Ext.Controller({
	'launch': function() {
		if (!FileRun.loaded) {
			FR.customActions = {};
			FR.ext = {};
			Ext.each(customActions, function(ca) {
				var name = ca.actionName;
					Ext.each(ca.extensions, function(ext) {
						if (!FR.ext[ext]) {FR.ext[ext] = [];}
						FR.ext[ext].push(name);
					});
				FR.customActions[name] = ca;
			});
			FileRun.stores.FileList = Ext.StoreMgr.get('FileList');
			FileRun.views.FileList = new FileRun.views.FileList();
			FileRun.views.viewport.insert(0, FileRun.views.FileList);
			FileRun.views.viewport.doLayout();
		}
		Ext.dispatch({
			controller: FileRun.controllers.FileList,
			action: 'launch'
		});
		FileRun.loaded = true;
	},
	'showLogin': function() {
		if (!FileRun.views.loginForm) {
			FileRun.views.loginForm = new FileRun.views.LoginForm();
		}
		FileRun.views.loginForm.show('pop');
	},
	'login': function() {
		FileRun.views.loginForm.setLoading(true, true);
		FileRun.views.loginForm.submit({
			url: '../?module=fileman&section=default&page=login&action=ajax_login',
			method: 'POST',
			success: function(form, rs) {
				FileRun.views.loginForm.setLoading(false);
				FileRun.views.loginForm.hide('pop');
				var fields = FileRun.views.loginForm.getFields();
				fields.username.setValue('');
				fields.password.setValue('');
				Ext.dispatch({
					controller: FileRun.controllers.app,
					action: 'launch'
				});
			},
			failure: function(form, rs) {
				FileRun.views.loginForm.setLoading(false);
				Ext.Msg.alert(FR.T('Login'), rs.error);
			}
		});
	},
	'logout': function() {
		FileRun.views.FileList.setLoading(true);
		Ext.Ajax.request({
			url: '?page=logout',
			success: function(response, opts) {
				FileRun.views.FileList.setLoading(false);
				var rs = Ext.decode(response.responseText);
				if (rs.rs) {
					Ext.dispatch({
						controller: FileRun.controllers.app,
						action: 'showLogin'
					});
				}
			}
		});
	},
	'openLinkInNewWindow': function(opt) {
		//awful hack to avoid pop-up blocking by smart phone browser.
		var lnk = Ext.getDom('hidden_link');
		var clickevent = document.createEvent('Event');
		lnk.href = opt.url;
		clickevent.initEvent('click', true, false);
		lnk.dispatchEvent(clickevent);
	}
});