FileRun.views.FilePanelV = Ext.extend(Ext.Panel, {
	initComponent: function() {
		FR.UI.buttons.fileBack = new Ext.Button({
			text: FR.T('Back'), ui: 'back',
			handler: function() {
				Ext.dispatch({
					controller: FileRun.controllers.FilePanel,
					action: 'backToList'
				});
			}
		});
		FR.UI.buttons.download = new Ext.Button({
			text: FR.T('Download'), ui: 'action',
			handler: function() {
				Ext.dispatch({
					controller: FileRun.controllers.FilePanel,
					action: 'download'
				});
			}
		});
		FR.UI.buttons.preview = new Ext.Button({
			text: FR.T('Preview'),
			hidden: true,
			handler: function(btn, e) {
				Ext.dispatch({
					controller: FileRun.controllers.FilePanel,
					action: 'preview'
				});
			}
		});
		FR.UI.buttons.more = new Ext.Button({
			text: FR.T('More...'),
			handler: function(btn, e) {
				this.moreMenu.showBy(btn);
			}, scope: this
		});
		FR.UI.buttons.openWith = new Ext.Button({
			text: FR.T('Open with...'), 
			style:'margin-bottom:5px;', 
			handler: function() {
				this.moreMenu.hide();
				this.openWithMenu.show('pop');
			}, scope: this
		});
		
		this.moreMenu = new Ext.Panel({
			styleHtmlContent: true,
			floating: true,
			centered: false,
			defaults: {xtype: 'button'},
			items: [
				FR.UI.buttons.openWith,
				{text: FR.T('Generate WebLink'), style:'margin-bottom:5px;', handler: function() {
					Ext.dispatch({
						controller: FileRun.controllers.FilePanel,
						action: 'getWebLink',
						btn: this
					});
				}},
				{text: FR.T('Delete'), handler: function() {
					Ext.dispatch({
						controller: FileRun.controllers.FilePanel,
						action: 'del',
						btn: this
					});
				}},
			]
		});
		this.openWithMenu = new Ext.Panel({
			styleHtmlContent: true, floating: true, centered: true, modal: true, html: '',
			listeners: {
				'beforeshow': function() {
					this.removeAll();
					Ext.each(FR.ext[FR.currentFile.x], function(aName) {
						var ca = FR.customActions[aName];
						this.insert(0, {xtype: 'button', text: ca.title, icon: '../'+ca.icon, style:'margin-bottom:5px;', handler: function() {
							if (ca.popup) {
								var url = '../?module=custom_actions&action='+ca.actionName;
								url += '&path='+encodeURIComponent(FR.currentPath);
								url += '&filename='+encodeURIComponent(FR.currentFile.n);
								Ext.dispatch({
									controller: FileRun.controllers.app,
									action: 'openLinkInNewWindow',
									url: url
								});
							} else {
								eval(ca.fn);
							}
							FileRun.views.FilePanel.openWithMenu.hide();
						}});
					}, this);
				},
				'show': function() {
					this.doComponentLayout();
				}
			}
		});
		
		this.formPanel = new Ext.form.FormPanel({
			submitOnAction: false,
			items: [
				{
					xtype: 'fieldset',
					defaultType: 'textfield',
					defaults: {
						labelWidth: 150
					},
					items: [
						{name: 'n', label: FR.T('Name'),
							listeners: {
								action: function () {
									Ext.dispatch({
										controller: FileRun.controllers.FilePanel,
										action: 'ren',
										newName: this.getValue()
									});
								}
							}
						},
						{name: 's2', label: FR.T('Size')},
						{name: 't', label: FR.T('Type')},
						{name: 'c', label: FR.T('Date Created')},
						{name : 'm2', label: FR.T('Date Modified')},
						{name : 'wl', label: FR.T('WebLink'),
							listeners: {
								action: function () {
									Ext.dispatch({
										controller: FileRun.controllers.FilePanel,
										action: 'removeWebLink'
									});
								}
							}
						}
					]
				}
			]
		});
		Ext.apply(this, {
			scroll: 'vertical',
			items: this.formPanel,
			dockedItems: [
				{
					xtype: 'toolbar',
					items: FR.UI.buttons.fileBack
				},
				{
					xtype: 'toolbar',
					dock: 'bottom',
					ui: 'light',
					items: [
						FR.UI.buttons.download,
						FR.UI.buttons.preview,
						FR.UI.buttons.more
					]
				}
			]
		})
		FileRun.views.FilePanelV.superclass.initComponent.apply(this, arguments);
	}
});
