FileRun.views.LoginForm = Ext.extend(Ext.form.FormPanel, {
	floating: !Ext.is.Phone,
	centered: true,
	modal: true,
	fullscreen: Ext.is.Phone,
	hideOnMaskTap: false,
	submitOnAction: false,
	scroll: Ext.is.Phone?'vertical':false,
	
	initComponent: function() {
		this.langField = new Ext.form.Select({
			name: 'language',
			label: FR.T('Language'),
			value: selectedLang,
			options: Languages,
			listeners: {
				'change': function(s, val) {
					if (Ext.get('langScript')) {
						Ext.get('langScript').remove();
					}
					var head = document.getElementsByTagName('head')[0];
					var script = document.createElement('script');
					script.id = 'langScript';
					script.type = 'text/javascript';
					script.src = langFileURL+'&language='+encodeURIComponent(val);
					head.appendChild(script);
				}
			}
		});
		Ext.apply(this, {
			items: [
				{
					xtype: 'fieldset',
					defaults: {
						autoCorrect: false, autoCapitalize: false
					},
					items: [
						{xtype: 'textfield', name: 'username', label: FR.T('Username')},
						{xtype: 'passwordfield', name: 'password', label: FR.T('Password')},
						this.langField
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					title: Settings.title
				},
				{
					xtype: 'toolbar',
					dock: 'bottom',
					ui: 'light',
					items: [
						{xtype: 'spacer'},
						{xtype: 'button', text: FR.T('Login'), handler: function (){
							Ext.dispatch({
								controller: FileRun.controllers.app,
								action: 'login'
							});
						}}
					]
				}
			],
			keys: [
				{key: [Ext.EventObject.ENTER], handler: function() {
					Ext.dispatch({
						controller: FileRun.controllers.app,
						action: 'login'
					});
				}}
			]
		});
		FileRun.views.LoginForm.superclass.initComponent.apply(this, arguments);
	}
});