<?php
$queries = array();


$queries[] = "DROP TABLE IF EXISTS `df_modules_folders_notifications`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_folders_notifications` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` int(9) NOT NULL,
  `pathid` int(9) NOT NULL,
  `shareid` int(8) DEFAULT NULL,
  `notify_write` int(1) NOT NULL DEFAULT '0',
  `notify_read` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`pathid`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_logs`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_logs` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `action` varchar(255) NOT NULL DEFAULT '',
  `data` text NOT NULL,
  `uid` mediumint(9) NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_modules_folders_hidden`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_folders_hidden` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `pathid` mediumint(9) NOT NULL,
  `for_gid` mediumint(9) DEFAULT NULL,
  `for_uid` mediumint(9) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `pathid` (`pathid`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_modules_metadata_dt`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_metadata_dt` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `owner` mediumint(9) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` varchar(255) NOT NULL,
  `extension` varchar(30) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_metadata_fields`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_metadata_fields` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `fsid` mediumint(9) NOT NULL,
  `name` varchar(100) NOT NULL,
  `description` varchar(255) NOT NULL,
  `type` varchar(50) NOT NULL,
  `options` text NOT NULL,
  `hide_fieldset_name_in_column` smallint(1) NOT NULL DEFAULT '0',
  `show_column_by_default` smallint(1) NOT NULL DEFAULT '0',
  `system` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "INSERT INTO `df_modules_metadata_fields` (`id`, `fsid`, `name`, `description`, `type`, `options`, `hide_fieldset_name_in_column`, `show_column_by_default`, `system`) VALUES (1, 1, 'comment', 'Required for the file commenting system', '', '', 1, 0, 1)";


$queries[] = "DROP TABLE IF EXISTS `df_modules_metadata_fieldsets`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_metadata_fieldsets` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `owner` mediumint(9) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `generic` smallint(1) NOT NULL DEFAULT '0',
  `system` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "INSERT INTO `df_modules_metadata_fieldsets` (`id`, `owner`, `name`, `description`, `generic`, `system`) VALUES
(1, 0, 'Comments (System)', 'Required for the file commenting system', 1, 1)";


$queries[] = "DROP TABLE IF EXISTS `df_modules_metadata_files`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_metadata_files` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `path` varchar(255) NOT NULL,
  `type_id` mediumint(9) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `path` (`path`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_metadata_values`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_metadata_values` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `date_added` datetime NOT NULL,
  `date_modified` datetime NOT NULL,
  `uid` mediumint(9) NOT NULL,
  `file_id` mediumint(9) NOT NULL,
  `field_id` mediumint(9) NOT NULL,
  `val` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fast_lookup` (`file_id`,`field_id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_notifications`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_notifications` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `owner` mediumint(9) DEFAULT NULL,
  `object_type` varchar(50) NOT NULL DEFAULT '',
  `object_id` mediumint(9) NOT NULL DEFAULT '0',
  `action` text NOT NULL,
  `email_address` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_pop_importer`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_pop_importer` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `title` varchar(255) NOT NULL,
  `server` varchar(255) NOT NULL,
  `username` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `port` varchar(255) NOT NULL,
  `use_ssl` smallint(1) NOT NULL DEFAULT '0',
  `msgids` blob NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_search_index_queue`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_search_index_queue` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `path` varchar(255) NOT NULL,
  `action` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_shares`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_shares` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `created` datetime NOT NULL,
  `path` varchar(255) NOT NULL,
  `type` varchar(20) NOT NULL,
  `alias` VARCHAR(50) NOT NULL DEFAULT  '',
  `comment` varchar(255) NOT NULL,
  `with_gid` mediumint(9) NOT NULL,
  `with_uid` mediumint(9) NOT NULL,
  `anonymous` smallint(1) NOT NULL DEFAULT '0',
  `perms_upload` varchar(1) NOT NULL DEFAULT '0',
  `perms_download` varchar(1) NOT NULL DEFAULT '0',
  `perms_comment` varchar(1) NOT NULL DEFAULT '0',
  `perms_read_comments` smallint(1) NOT NULL DEFAULT '0',
  `perms_alter` varchar(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`path`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_trash`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_trash` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `relative_path` varchar(255) NOT NULL,
  `date_deleted` datetime NOT NULL,
  `filesize` bigint(15) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_user_groups`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_user_groups` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `owner` mediumint(9) DEFAULT NULL,
  `description` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "DROP TABLE IF EXISTS `df_modules_user_roles`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_user_roles` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `owner` mediumint(9) NOT NULL,
  `name` varchar(50) NOT NULL,
  `description` varchar(100) NOT NULL,
  `admin_type` varchar(20) NOT NULL,
  `admin_users` smallint(1) NOT NULL DEFAULT '0',
  `admin_roles` smallint(1) NOT NULL DEFAULT '0',
  `admin_notifications` smallint(1) NOT NULL DEFAULT '0',
  `admin_logs` smallint(1) NOT NULL DEFAULT '0',
  `admin_metadata` smallint(1) NOT NULL DEFAULT '0',
  `admin_over` text NOT NULL,
  `admin_max_users` smallint(7) NOT NULL DEFAULT '0',
  `admin_homefolder_template` varchar(255) NOT NULL,
  `homefolder` varchar(255) NOT NULL,
  `create_folder` smallint(1) NOT NULL DEFAULT '1',
  `space_quota_max` int(20) DEFAULT NULL,
  `space_quota_current` int(20) NOT NULL DEFAULT '0',
  `traffic_quota_max` int(20) DEFAULT NULL,
  `readonly` smallint(1) DEFAULT NULL,
  `upload` smallint(1) DEFAULT NULL,
  `download` smallint(1) DEFAULT NULL,
  `download_folders` smallint(1) DEFAULT NULL,
  `read_comments` smallint(1) DEFAULT NULL,
  `write_comments` smallint(1) DEFAULT NULL,
  `email` smallint(1) NOT NULL DEFAULT '0',
  `weblink` smallint(1) NOT NULL DEFAULT '0',
  `share` smallint(1) NOT NULL DEFAULT '0',
  `metadata` smallint(1) NOT NULL DEFAULT '0',
  `users_may_see` varchar(255) NOT NULL DEFAULT '-ALL-',
  `change_pass` smallint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_modules_weblinks`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_modules_weblinks` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `pathid` mediumint(9) NOT NULL,
  `relative_path` varchar(255) DEFAULT NULL,
  `short_url` varchar(255) DEFAULT NULL,
  `password` varchar(32) DEFAULT NULL,
  `expiry` datetime DEFAULT NULL,
  `download_limit` mediumint(6) DEFAULT NULL,
  `allow_uploads` int(1) NOT NULL DEFAULT '0',
  `system` smallint(1) NOT NULL DEFAULT '0',
  `notify` mediumint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`pathid`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_paths`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_paths` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `path` text NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`id`),
  FULLTEXT KEY `path` (`path`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_relationships`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_relationships` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `related_to_id` mediumint(9) NOT NULL DEFAULT '0',
  `object_id` mediumint(9) NOT NULL DEFAULT '0',
  `relation_type` varchar(50) NOT NULL DEFAULT '',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM";

$queries[] = "DROP TABLE IF EXISTS `df_settings`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_settings` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `var` varchar(50) NOT NULL,
  `val` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `var` (`var`)
) ENGINE=MyISAM";

$queries[] = "INSERT INTO `df_settings` (`var`, `val`) VALUES
('currentVersion', '161012'),
('app_title', 'FileRun'),
('thumbnails_enable', '1'),
('thumbnails_size', '80'),
('thumbnails_imagemagick', '0'),
('thumbnails_imagemagick_path', '/usr/bin/convert'),
('thumbnails_imagemagick_ext', 'psd,eps,png,tst,plt,ai,pdf'),
('thumbnails_ffmpeg', '0'),
('thumbnails_ffmpeg_path', '/usr/bin/ffmpeg'),
('thumbnails_ffmpeg_ext', 'mpg,mpeg,mp4,mov,avi,divx,mkv,wmv,rm,flv,asx,asf,swf,3gp,3g2,m4v,m2ts,mts,m2v'),
('smtp_enable', '0'),
('smtp_auth', '1'),
('smtp_host', 'localhost'),
('smtp_port', '25'),
('smtp_username', ''),
('smtp_password', ''),
('user_registration_enable', '0'),
('user_registration_generate_passwords', '0'),
('user_registration_email_verification', '1'),
('user_registration_approval', '0'),
('user_registration_reqfields_email', '1'),
('user_registration_reqfields_company', '0'),
('user_registration_reqfields_website', '0'),
('user_registration_reqfields_description', '0'),
('user_registration_perms_upload', '1'),
('user_registration_perms_download', '1'),
('user_registration_perms_weblink', '1'),
('user_registration_perms_email', '1'),
('user_registration_perms_home_folder', '/some/path/{username}/{email}/{name}/{company}/{description}'),
('user_registration_perms_readonly', '0'),
('user_registration_create_folder', '0'),
('user_registration_perms_space_quota_max', ''),
('user_registration_perms_share', '0'),
('user_registration_perms_traffic_quota_max', ''),
('user_registration_perms_metadata', '0'),
('user_registration_change_pass', 'on'),
('user_registration_perms_change_pass', '0'),
('user_registration_perms_notifications', '1'),
('user_registration_default_groups', ''),
('user_registration_default_role', ''),
('system_traffic_quota_reset_date', ''),
('quota_warning_level', '90'),
('allow_change_pass', '1'),
('password_recovery_enable', '1'),
('max_login_attempts', '4'),
('allow_persistent_login', '1'),
('logout_redirect', ''),
('search_enable', '0'),
('search_converters_text', ''),
('ui_default_view', 'thumbnails'),
('ui_enable_flash_upload', '1'),
('ui_default_upload_mode', 'flash'),
('ui_enable_dnd_upload', '1'),
('ui_enable_pop_importer', '1'),
('allow_pop_importer', '1'),
('ui_enable_full_screen', '0'),
('ui_default_language', 'english'),
('ui_display_language_menu', '1'),
('ui_double_click', 'preview'),
('ui_window_width', '900'),
('ui_window_height', '580'),
('ui_login_logo', ''),
('ui_login_text', ''),
('dnd_chunk_size', '2'),
('fancy_weblinks', '0'),
('disable_versioning', '0'),
('last_email_notification', NOW()),
('instant_email_notifications', '1'),
('default_notification_address', 'some@email-address.com'),
('password_recovery_force_change', '1'),
('ui_enable_create_file', '1'),
('allow_folder_notifications', '1'),
('upload_blocked_types', NULL)";


$queries[] = "DROP TABLE IF EXISTS `df_users`";
$queries[] = "CREATE TABLE IF NOT EXISTS `df_users` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `cookie` varchar(255) NOT NULL,
  `owner` mediumint(9) DEFAULT NULL,
  `registration_date` datetime NOT NULL,
  `activated` smallint(1) NOT NULL DEFAULT '0',
  `expiration_date` datetime DEFAULT NULL,
  `require_password_change` int(1) NOT NULL DEFAULT '0',
  `failed_login_attempts` smallint(1) NOT NULL DEFAULT '0',
  `last_login_date` datetime NOT NULL,
  `last_logout_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `email` varchar(255) NOT NULL DEFAULT '',
  `receive_notifications` smallint(1) NOT NULL,
  `new_email` varchar(255) NOT NULL,
  `name` varchar(100) NOT NULL,
  `company` varchar(255) NOT NULL,
  `website` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `logo_url` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";


$queries[] = "INSERT INTO `df_users` (`id`, `username`, `password`, `cookie`, `owner`, `registration_date`, `activated`, `failed_login_attempts`, `last_login_date`, `last_logout_date`, `email`, `receive_notifications`, `new_email`, `name`, `company`, `website`, `description`, `logo_url`) VALUES (1, 'admin', '21232f297a57a5a743894a0e4a801fc3', '', NULL, NOW(), 1, 0, NOW(), NOW(), '', 0, '', 'Superuser', '', '', '', '')";


$queries[] = "DROP TABLE IF EXISTS `df_users_permissions`";

$queries[] = "CREATE TABLE IF NOT EXISTS `df_users_permissions` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(9) NOT NULL,
  `role` mediumint(9) DEFAULT NULL,
  `admin_type` varchar(20) DEFAULT NULL,
  `admin_users` smallint(1) NOT NULL DEFAULT '0',
  `admin_roles` smallint(1) NOT NULL DEFAULT '0',
  `admin_notifications` smallint(1) NOT NULL DEFAULT '0',
  `admin_logs` smallint(1) NOT NULL DEFAULT '0',
  `admin_metadata` smallint(1) NOT NULL DEFAULT '0',
  `admin_over` text NOT NULL,
  `admin_max_users` smallint(7) NOT NULL DEFAULT '0',
  `admin_homefolder_template` varchar(255) NOT NULL,
  `homefolder` varchar(255) DEFAULT NULL,
  `space_quota_max` int(20) DEFAULT NULL,
  `space_quota_current` int(20) NOT NULL DEFAULT '0',
  `traffic_quota_max` int(20) DEFAULT NULL,
  `traffic_quota_current` int(20) NOT NULL DEFAULT '0',
  `readonly` smallint(1) DEFAULT NULL,
  `upload` smallint(1) DEFAULT NULL,
  `download` smallint(1) DEFAULT NULL,
  `download_folders` smallint(1) DEFAULT NULL,
  `read_comments` smallint(1) DEFAULT NULL,
  `write_comments` smallint(1) DEFAULT NULL,
  `email` smallint(1) NOT NULL DEFAULT '0',
  `weblink` smallint(1) NOT NULL DEFAULT '0',
  `share` smallint(1) NOT NULL DEFAULT '0',
  `metadata` smallint(1) NOT NULL DEFAULT '0',
  `users_may_see` varchar(255) NOT NULL DEFAULT '-ALL-',
  `change_pass` smallint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM";

$queries[] = "INSERT INTO `df_users_permissions` (`id`, `uid`, `role`, `admin_type`, `admin_users`, `admin_roles`, `admin_notifications`, `admin_logs`, `admin_metadata`, `admin_over`, `admin_max_users`, `admin_homefolder_template`, `homefolder`, `space_quota_max`, `space_quota_current`, `traffic_quota_max`, `traffic_quota_current`, `readonly`, `upload`, `download`, `download_folders`, `read_comments`, `write_comments`, `email`, `weblink`, `share`, `metadata`, `users_may_see`, `change_pass`) VALUES (1, 1, 0, '', 1, 1, 1, 1, 1, '', 0, '', '/', 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, '-ALL-', 1)";

foreach ($queries as $query) {
	$rs = @mysql_query($query);
	if (!$rs) {
		$feedback[] =  array("MySQL error: ".mysql_error().", in: ".$query, "error");
	}
}
?>