FR = {
	initialized: false,
	currentH: 430, currentW: 460, viewPortHeight: 430, viewPortWidth: 460,
	offset: 40,
	pageIndex: false, fitToPage: true,
	init: function() {
		Ext.QuickTips.init();
		this.baseSrc = URLRoot+'/?module=fileman_myfiles&section=ajax&page=thumbnail';
		this.toolbar = new Ext.Toolbar({
			items: [
			{
				icon: URLRoot+'/images/fileman/interface/icons/arrow_in.gif',
				tooltip: {text: 'Fit to window', showDelay:0},
				enableToggle: true,
				toggleHandler:  function(item, pressed) {
					if (pressed) {
						FR.fitToPage = true;
						FR.fitToViewPort();
					} else {
						FR.fitToPage = false;
						FR.resizeImage(2000, 2000);
					}
				},
				pressed: true
			},
			{
				id: 'fr-prevpg-btn',
				disabled: true, tooltip: {text: 'Previous Page', showDelay:0},
				iconCls: "x-tbar-page-prev",
				handler: function() {return FR.previousPage();}
			},
			{
				id: 'fr-nextpg-btn',
				iconCls: "x-tbar-page-next",
				tooltip: {text: 'Next Page', showDelay:0},
				handler: function() {return FR.nextPage();}
			},
			'->',
			{
				id: 'fr-prev-btn',
				disabled: true,
				iconCls: "x-tbar-page-prev", tooltip: {text: 'Previous File', showDelay:0},
				handler: function() {return FR.previousFile();}
			},
			'<input type="text" size="5" id="infoField" value="" style="text-align:center">',
			{
				id: 'fr-next-btn',
				iconCls: "x-tbar-page-next", tooltip: {text: 'Next File', showDelay:0},
				handler: function() {return FR.nextFile();}
			}
		]});
		this.viewport = new Ext.Viewport({
			layout: 'border',
			border: false,
			hideBorders: true,
			autoHeigh: true,
			items: [
				{
					bbar: this.toolbar,
					id: 'theCenter',
					region: 'center',
					layout: 'fit',
					autoHeigh: true,
					html: '<table style="width:100%;height:100%;" id="tblEl"><tr><td valign="center" align="center"><div id="imgPlaceHolder"></div></td></tr></table>'
				}
			],
			listeners: {
				'resize': function() {if (FR.fitToPage) {FR.fitToViewPort();} else {FR.centerImage();}}
			}
		});
		new Ext.dd.DD('tblEl');
		this.toolbar.getEl().child("table").wrap({tag:'center'});
		this.imgDOM = Ext.get(Ext.DomHelper.createDom({tag: 'img', src:'', border:0, alt:'', style: '-webkit-box-shadow: #333 2px 2px 6px;box-shadow: #333 2px 2px 6px;-moz-box-shadow:#333 2px 2px 6px'}));
		Ext.get('imgPlaceHolder').appendChild(this.imgDOM);
		this.imgDOM.addListener('load', function() {
			this.fadeIn();
			FR.centerImage();
		});
		this.loadFile(this.currentIndex);
	},
	fitToViewPort: function() {
		if (FR.initialized) {
			FR.viewPortWidth = FR.viewport.getWidth();
			FR.viewPortHeight = FR.viewport.getHeight();
			FR.resizeImage(FR.viewPortWidth, FR.viewPortHeight);
		}
	},
	resizeImage: function(w, h) {
		if (FR.initialized) {
			this.imgDOM.fadeOut();
			this.centerImage();
			FR.currentH = h-FR.offset;
			FR.currentW = w-FR.offset;
			var src = FR.baseSrc+'&path='+encodeURIComponent(FR.path);
			src += '&filename='+encodeURIComponent(FR.currentFilename)+'&naturalSize=1&noCache=1';
			src += '&width='+FR.currentW+'&height='+FR.currentH;
			src += '&pageNo='+FR.pageIndex;
			this.imgDOM.set({src:src});
		}
	},
	centerImage: function() {
		Ext.get('tblEl').alignTo(FR.viewport.getEl(), 'c-c', [0, -15]);
	},
	loadFile: function(index, pageIndex) {
		if (!FR.fitToPage) {
			FR.currentH = 2000;
			FR.currentW = 2000;
		} else {
			FR.currentH = FR.viewport.getHeight()-FR.offset;
			FR.currentW = FR.viewport.getWidth()-FR.offset;
		}
		var filename = this.files[index];
		Ext.get('infoField').set({value: ((this.currentIndex+1)+'/'+this.countFiles)});
		this.currentFilename = filename;
		window.parent.FR.UI.popups[this.popupId].setTitle(filename);
		window.parent.FR.previewData = {path: this.path, filename: filename};
		if (!pageIndex) {
			this.pageIndex = 0;
		} else {
			this.pageIndex = pageIndex;
		}
		var src = this.baseSrc+'&path='+encodeURIComponent(this.path);
		src += '&filename='+encodeURIComponent(filename)+'&naturalSize=1&noCache=1';
		src += '&width='+this.currentW+'&height='+this.currentH;
		src += '&pageNo='+this.pageIndex;

		this.imgDOM.fadeOut();
		this.imgDOM.set({src: src});
		
		this.initialized = true;
		var fileExtension = window.parent.FR.utils.getFileExtension(filename);
		if (fileExtension == 'pdf') {
			Ext.getCmp('fr-prevpg-btn').show();
			Ext.getCmp('fr-nextpg-btn').show();
			if (this.pageIndex > 0) {
				Ext.getCmp('fr-prevpg-btn').enable();
			} else {
				Ext.getCmp('fr-prevpg-btn').disable();
			}
		} else {
			Ext.getCmp('fr-prevpg-btn').hide();
			Ext.getCmp('fr-nextpg-btn').hide();
		}
		if (this.currentIndex < this.countFiles-1) {
			Ext.getCmp('fr-next-btn').enable();
		} else {
			Ext.getCmp('fr-next-btn').disable();
		}
		if (this.currentIndex > 0) {
			Ext.getCmp('fr-prev-btn').enable();
		} else {
			Ext.getCmp('fr-prev-btn').disable();
		}
	},
	nextFile: function() {
		if (this.currentIndex < this.countFiles-1) {
			this.currentIndex++;
			this.loadFile(this.currentIndex);
		}
	},
	previousFile: function() {
		if (this.currentIndex > 0) {
			this.currentIndex--;
			this.loadFile(this.currentIndex);
		}
	},
	nextPage: function() {
		this.pageIndex++;
		this.loadFile(this.currentIndex, this.pageIndex);
	},
	previousPage: function() {
		if (this.pageIndex > 0) {
			this.pageIndex--;
			this.loadFile(this.currentIndex, this.pageIndex);
		}
	}
}